<?php

// My Click Boss - Version 1.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// was this page called by a form POST?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	// get form fields
	$description = $_POST['description'];
	$rotator_type = $_POST['rotator_type'];
	$default_url = $_POST['default_url'];
	$notes = $_POST['notes'];

	$displaymessagebox = "y";

	// check fields for errors
	$errorcount = 0;
	$displaymessage = "";

	// $description
	$description = trim($description);
	if ($description == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($description) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $default_url
	$default_url = trim($default_url);
	if ($default_url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Default URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Default URL' field can't be blank.";
		}
		$errorcount++;
	}	

	// process if no errors
	if ($errorcount == 0) {
		// generate unique rotator_click_tracking_code (append r)
		$url_code_length = 10;
		// generate code
		// exit with fatal error if a code can't be found in a reasonable number of trys
		$go = true;
		$short_url_chars = 'abcdefghijklmnopqrstuvwxyz0123456789';
		while($go){
			$short_url_code = '';
			for($i = 0; $i < $url_code_length; $i++){
				$pos = mt_rand(0, strlen($short_url_chars)-1);
				$short_url_code .= substr($short_url_chars, $pos, 1);
			}
			$short_url_code = 'r' . $short_url_code;
			// is it already in use?
			$sql_temp = "SELECT * FROM click_rotators WHERE rotator_click_tracking_code = '$short_url_code'";
			$result_temp = $mysqli->query($sql_temp);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			$count = $result_temp->num_rows;
			$result_temp->close();
			if ($count < 1) {
				$go = false;
			}
		} // end while
		$rotator_click_tracking_code = $short_url_code;
		
		// sanitize data as needed
		$description = sanitize($description, $mysqli);
		$default_url = sanitize($default_url, $mysqli);
		$notes = sanitize($notes, $mysqli);
		
		// save new click_rotators record
		$sql = "INSERT INTO click_rotators (description, rotator_type, default_url, rotator_click_tracking_code, notes) values ('$description', '$rotator_type', '$default_url', '$rotator_click_tracking_code', '$notes')";		
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not insert record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}

		// stripslashes as needed
		$description = stripslashes($description);
		$default_url = stripslashes($default_url);
		$notes = stripslashes(str_replace('\r\n', "\n", $notes));

		// create rotator_link to display
		$rotator_link = $rotator_url . "?a=" . $rotator_click_tracking_code;
	
		// prep data as needed for display

		$displaymessage = "New click rotator has been created.";		
	}
} else {
	// clear form field variables
	$description = "";
	$rotator_type = "Series";
	$default_url = "";
	$rotator_click_tracking_code = "";
	$notes = "";
	
	$rotator_link = "";
	
	$displaymessagebox = "n";
	$displaymessage = "";
	$errorcount = 0;
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Add New Click Rotator</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Add New Click Rotator</h1></div><!-- END #page_name -->
	<div id="page_description">
		Enter the information for the new click rotator below.</div><!-- END #page_description -->
	<div id="form_section">

<?php
if ($displaymessagebox == "y") {
	echo "<table>";
	echo "<tr>";
	if ($errorcount > 0) {
		echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
	} else {
		echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
	}
	echo "</tr>";
	echo "</table>";
	echo "<br>";
}
?>

<center>
<form method="post" id="addnewclickrotator" name="addnewclickrotator" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">
<table>
<tr>
<td width="162" class="txtRight bold">Description:</td>
<td width="596"><input type="text" id="description" name="description" size="50" value="<?php echo $description; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Rotator Type:</td>
<td width="596">
<select size="1" id="rotator_type" name="rotator_type">
<?php
	if ($rotator_type == "Series") {
	      	echo "<option selected value=\"Series\">Series</option>";
	      	echo "<option value=\"Rotate\">Rotate</option>";
	} else {
	      	echo "<option value=\"Series\">Series</option>";
	      	echo "<option selected value=\"Rotate\">Rotate</option>";
	}
?>
</select>
</td>
</tr>
<tr>
<td width="162" class="txtRight bold">Default URL:</td>
<td width="596"><input type="text" id="default_url" name="default_url" size="50" value="<?php echo $default_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Rotator Link:</td>
<td width="596"><?php echo $rotator_link; ?></td>
</tr>
<tr>
<td valign="top" class="txtRight bold">Notes:</td>
<td><textarea rows="5" name="notes" cols="55"><?php echo $notes; ?></textarea></td>
</tr>
</table>
<br>            
<input type="submit" name="submit" id="submit" value="Add New Click Rotator">
</form>
</center>
<br><br>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
