<?php

// My Click Boss - Version 3.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// was this page called by a form POST?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	// get form fields
	$description = $_POST['description'];
	$trade_partners_url = $_POST['trade_partners_url'];
	$my_url = $_POST['my_url'];
	$trade_partners_stats_password = $_POST['trade_partners_stats_password'];
	$notes = $_POST['notes'];
	$alert_when_number_clicks_sent = $_POST['alert_when_number_clicks_sent'];
	$add_to_rotator = $_POST['add_to_rotator'];
	$rotator_clicks_to_send = $_POST['rotator_clicks_to_send'];

	$displaymessagebox = "y";

	// prep any variables
	$click_tracking_code = strtolower($click_tracking_code);

	if ($rotator_clicks_to_send == "") {
		$rotator_clicks_to_send = 0;
	}
	
	// check fields for errors
	$errorcount = 0;
	$displaymessage = "";

	// $description
	$description = trim($description);
	if ($description == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($description) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $trade_partners_url
	$trade_partners_url = trim($trade_partners_url);
	if ($trade_partners_url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Trade Partners URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Trade Partners URL' field can't be blank.";
		}
		$errorcount++;
	}	
	// $my_url
	$my_url = trim($my_url);
	if ($my_url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'My URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'My URL' field can't be blank.";
		}
		$errorcount++;
	}	
	// $trade_partners_stats_password
	$trade_partners_stats_password = trim($trade_partners_stats_password);
	if ($trade_partners_stats_password == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Trade Partners Stats Password' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Trade Partners Stats Password' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($trade_partners_stats_password) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Trade Partners Stats Password' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Trade Partners Stats Password' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $alert_when_number_clicks_sent
	if ($alert_when_number_clicks_sent == "") {
		$alert_when_number_clicks_sent = 0;
	}
	// is alert_when_number_clicks_sent an integer?
	if(!preg_match('/^[0-9]+$/', $alert_when_number_clicks_sent)) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($alert_when_number_clicks_sent < 0) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($alert_when_number_clicks_sent > 999999999) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}

	// rotator_clicks_to_send
	if ($add_to_rotator > 0) {
		if(!preg_match('/^[0-9]+$/', $rotator_clicks_to_send)) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		if ($rotator_clicks_to_send < 0) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		if ($rotator_clicks_to_send > 999999999) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}	
	}
	
	// process if no errors
	if ($errorcount == 0) {
		// generate unique inbound_click_tracking_code and outbound_click_tracking_code (append i,o)
		// inbound_click_tracking_code
		$url_code_length = 10;
		// generate code
		// exit with fatal error if a code can't be found in a reasonable number of trys
		$go = true;
		$short_url_chars = 'abcdefghijklmnopqrstuvwxyz0123456789';
		while($go){
			$short_url_code = '';
			for($i = 0; $i < $url_code_length; $i++){
				$pos = mt_rand(0, strlen($short_url_chars)-1);
				$short_url_code .= substr($short_url_chars, $pos, 1);
			}
			$short_url_code = 'i' . $short_url_code;
			// is it already in use?
			$sql_temp = "SELECT * FROM click_trades WHERE inbound_click_tracking_code = '$short_url_code'";
			$result_temp = $mysqli->query($sql_temp);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			$count = $result_temp->num_rows;
			$result_temp->close();
			if ($count < 1) {
				$go = false;
			}
		} // end while
		$inbound_click_tracking_code = $short_url_code;
		// outbound_click_tracking_code
		$url_code_length = 10;
		// generate code
		// exit with fatal error if a code can't be found in a reasonable number of trys
		$go = true;
		$short_url_chars = 'abcdefghijklmnopqrstuvwxyz0123456789';
		while($go){
			$short_url_code = '';
			for($i = 0; $i < $url_code_length; $i++){
				$pos = mt_rand(0, strlen($short_url_chars)-1);
				$short_url_code .= substr($short_url_chars, $pos, 1);
			}
			$short_url_code = 'o' . $short_url_code;
			// is it already in use?
			$sql_temp = "SELECT * FROM click_trades WHERE outbound_click_tracking_code = '$short_url_code'";
			$result_temp = $mysqli->query($sql_temp);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			$count = $result_temp->num_rows;
			$result_temp->close();
			if ($count < 1) {
				$go = false;
			}
		} // end while
		$outbound_click_tracking_code = $short_url_code;

		// sanitize data as needed
		$description = sanitize($description, $mysqli);
		$trade_partners_url = sanitize($trade_partners_url, $mysqli);
		$my_url = sanitize($my_url, $mysqli);
		$trade_partners_stats_password = sanitize($trade_partners_stats_password, $mysqli);
		$notes = sanitize($notes, $mysqli);
		
		// save new click_trades record
		$sql = "INSERT INTO click_trades (description, trade_partners_url, my_url, date_click_trade_created, inbound_click_tracking_code, outbound_click_tracking_code, total_clicks_received, total_clicks_sent, alert_when_number_clicks_sent, email_alert_sent, trade_partners_stats_password, trade_status, notes) values ('$description', '$trade_partners_url', '$my_url', now(), '$inbound_click_tracking_code', '$outbound_click_tracking_code', 0, 0, $alert_when_number_clicks_sent, 'No', '$trade_partners_stats_password', 'Active', '$notes')";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not insert record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}

		// get click_trades id
		$sql_temp = "SELECT * FROM click_trades WHERE inbound_click_tracking_code = '$inbound_click_tracking_code'";
		$result_temp = $mysqli->query($sql_temp);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
		$row_temp = $result_temp->fetch_array(MYSQLI_BOTH);
		$click_trades_id = $row_temp['id'];
		$result_temp->close();

		// create click tracking urls to display
		$inbound_click_tracking_url = $trades_url . "?a=" . $inbound_click_tracking_code;
		$outbound_click_tracking_url = $trades_url . "?a=" . $outbound_click_tracking_code;

		// add to rotator if selected
		// $add_to_rotator, $rotator_clicks_to_send
		if ($add_to_rotator > 0) {
			$click_rotators_id = $add_to_rotator;	
			$total_clicks_to_send = $rotator_clicks_to_send;
			$link_description = $description;
			$link_url = sanitize($outbound_click_tracking_url, $mysqli);
			
			// calculate series position (place last)
			$sql = "SELECT * FROM click_rotator_links WHERE click_rotators_id = $click_rotators_id ORDER BY series_position DESC";
			$result = $mysqli->query($sql);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			$count = $result->num_rows;
			if ($count > 0) {
				$row = $result->fetch_array(MYSQLI_BOTH);
				$series_position = $row['series_position'] + 1;
				$result->close();
			} else {
				$series_position = 1;
			}
		
			// save new click_rotator_links record
			$sql = "INSERT INTO click_rotator_links (click_rotators_id, series_position, link_description, link_url, total_clicks_to_send) values ($click_rotators_id, $series_position, '$link_description', '$link_url', $total_clicks_to_send)";		
			$result = $mysqli->query($sql);
			if ($mysqli->connect_errno) {
				echo "Could not insert record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
		}
		
		// stripslashes as needed
		$description = stripslashes($description);
		$trade_partners_url = stripslashes($trade_partners_url);
		$my_url = stripslashes($my_url);
		$trade_partners_stats_password = stripslashes($trade_partners_stats_password);
		$notes = stripslashes(str_replace('\r\n', "\n", $notes));

		// create pixel url to display
		$pixel_tracking_code = "<img src='" . $pixel_tracker_url . "?ptl=main' width='1' height='1'>";
		
		// create trade stats url
		$stats_link = $trade_stats_url . "?i=" . $click_trades_id . "&p=" . $trade_partners_stats_password;
		
		// prep data as needed for display

		$displaymessage = "New click trade has been created.";		
	}
} else {
	// clear form field variables
	$description = "";
	$trade_partners_url = "";
	$my_url = "";
	$trade_partners_stats_password = "";
	$notes = "";
	$alert_when_number_clicks_sent = "";
	// on the fly created variables
	$inbound_click_tracking_url = "";
	$outbound_click_tracking_url = "";
	$pixel_tracking_code = "";
	$stats_link = "";
	$add_to_rotator = 0;
	$rotator_clicks_to_send = "";
	
	$displaymessagebox = "n";
	$displaymessage = "";
	$errorcount = 0;
}

// get click_rotators
$sql_rotators = "SELECT * FROM click_rotators";
$result_rotators = $mysqli->query($sql_rotators);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Add New Click Trade</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Add New Click Trade</h1></div><!-- END #page_name -->
	<div id="page_description">
		Enter the information for the new click trade below.</div><!-- END #page_description -->
	<div id="form_section">

<?php
if ($displaymessagebox == "y") {
	echo "<table>";
	echo "<tr>";
	if ($errorcount > 0) {
		echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
	} else {
		echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
	}
	echo "</tr>";
	echo "</table>";
	echo "<br>";
}
?>

<center>
<form method="post" id="addnewclicktrade" name="addnewclicktrade" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">
<table>

<tr>
<td width="162" class="txtRight bold">Description:</td>
<td width="596"><input type="text" id="description" name="description" size="50" value="<?php echo $description; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Trade Partners Stats Password:</td>
<td width="596"><input type="text" id="trade_partners_stats_password" name="trade_partners_stats_password" size="50" value="<?php echo $trade_partners_stats_password; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Trade Partners Click URL:</td>
<td width="596"><input type="text" id="trade_partners_url" name="trade_partners_url" size="50" value="<?php echo $trade_partners_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">My Click URL:</td>
<td width="596"><input type="text" id="my_url" name="my_url" size="50" value="<?php echo $my_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Sent Click Count Alert:</td>
<td width="596"><input type="text" id="alert_when_number_clicks_sent" name="alert_when_number_clicks_sent" size="5" value="<?php echo $alert_when_number_clicks_sent; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Add to Rotator:</td>
<td width="596">
<select size="1" id="add_to_rotator" name="add_to_rotator">
<?php
if ($add_to_rotator == 0) {
	echo "<option selected value=\"0\"></option>";
} else {
	echo "<option value=\"0\"></option>";
}
while ($row_rotators = $result_rotators->fetch_array(MYSQLI_BOTH)) {
	$rotator_id = $row_rotators['id'];
	$rotator_description = stripslashes($row_rotators['description']);
	if ($add_to_rotator == $rotator_id) {
		echo "<option selected value=\"$rotator_id\">$rotator_description</option>";
	} else {
		echo "<option value=\"$rotator_id\">$rotator_description</option>";
	}	
}
$result_rotators->close();
?>
</select>
</td>
</tr>
<tr>
<td width="162" class="txtRight bold">Clicks to Send (Rotator):</td>
<td width="596"><input type="text" id="rotator_clicks_to_send" name="rotator_clicks_to_send" size="10" value="<?php echo $rotator_clicks_to_send; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Inbound Click Tracking Link:</td>
<td width="596"><input type="text" id="inbound_click_tracking_url" name="inbound_click_tracking_url" size="75" value="<?php echo $inbound_click_tracking_url; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Outbound Click Tracking Link:</td>
<td width="596"><input type="text" id="outbound_click_tracking_url" name="outbound_click_tracking_url" size="75" value="<?php echo $outbound_click_tracking_url; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Pixel Code:</td>
<td width="596"><input type="text" id="pixel_tracking_code" name="pixel_tracking_code" size="75" value="<?php echo $pixel_tracking_code; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Partner Stats URL:</td>
<td width="596"><input type="text" id="stats_link" name="stats_link" size="75" value="<?php echo $stats_link; ?>" readonly></td>
</tr>
<tr>
<td valign="top" class="txtRight bold">Notes:</td>
<td><textarea rows="5" name="notes" cols="55"><?php echo $notes; ?></textarea></td>
</tr>
</table>
<br>            
<input type="submit" name="submit" id="submit" value="Add New Click Trade">
</form>
</center>
<br><br>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
