<?php

// My Click Boss - Version 3.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";
require_once('js/calendar/classes/tc_calendar.php');

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// set calendar state
$calendar_state = 0;

// was this page called by a form POST?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	// get form fields
	$click_rotators_id = $_POST['click_rotators_id'];
	$link_description = $_POST['link_description'];
	$link_url = $_POST['link_url'];
	$total_clicks_to_send = $_POST['total_clicks_to_send'];
	$click_trades_i_code = $_POST['click_trades_i_code'];
	$notes = $_POST['notes'];
	$country_codes_accepted = $_POST['country_codes_accepted'];
	$country_codes_not_accepted = $_POST['country_codes_not_accepted'];
	$daily_click_limit = $_POST['daily_click_limit'];

	// get calendar and time fields
	$start_date = isset($_REQUEST["start_date"]) ? $_REQUEST["start_date"] : "";
	$start_hour = $_POST['start_hour'];
	$start_minute = $_POST['start_minute'];
	$end_date = isset($_REQUEST["end_date"]) ? $_REQUEST["end_date"] : "";
	$end_hour = $_POST['end_hour'];
	$end_minute = $_POST['end_minute'];

	// prep calendar and time fields
	if ($start_date == "0000-00-00" || $start_date == "") {
		$start_date_time = "0000-00-00 00:00:00";
	} else {
		$start_date_time = $start_date . " " . $start_hour . ":" . $start_minute . ":00";
	}
	if ($end_date == "0000-00-00" || $end_date == "") {
		$end_date_time = "0000-00-00 00:00:00";
	} else {
		$end_date_time = $end_date . " " . $end_hour . ":" . $end_minute . ":00";
	}
	
	// prep number fields as needed
	if($daily_click_limit == "") {
		$daily_click_limit = 0;
	}
	
	$displaymessagebox = "y";

	// check fields for errors
	$errorcount = 0;
	$displaymessage = "";

	// $link_description
	$link_description = trim($link_description);
	if ($link_description == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Link Description' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Link Description' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($link_description) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Link Description' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Link Description' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $link_url
	$link_url = trim($link_url);
	if ($link_url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Link URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Link URL' field can't be blank.";
		}
		$errorcount++;
	}	
	// $total_clicks_to_send
	if ($total_clicks_to_send == "") {
		$total_clicks_to_send = 0;
	}
	// is total_clicks_to_send an integer?
	if(!preg_match('/^[0-9]+$/', $total_clicks_to_send)) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Total Clicks to Send' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Total Clicks to Send' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($total_clicks_to_send < 0) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Total Clicks to Send' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Total Clicks to Send' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($total_clicks_to_send > 999999999) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Total Clicks to Send' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Total Clicks to Send' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}

	// $daily_click_limit
	// is daily_click_limit an integer?
	if(!preg_match('/^[0-9]+$/', $daily_click_limit)) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Daily Click Limit' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Daily Click Limit' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($daily_click_limit < 0) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Daily Click Limit' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Daily Click Limit' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($daily_click_limit > 999999999) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Daily Click Limit' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Daily Click Limit' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	
	// set calendar state
	$calendar_state = 1;
	
	// process if no errors
	if ($errorcount == 0) {		
		// sanitize data as needed
		$link_description = sanitize($link_description, $mysqli);
		$link_url = sanitize($link_url, $mysqli);
		$click_trades_i_code = sanitize($click_trades_i_code, $mysqli);
		$notes = sanitize($notes, $mysqli);
		$country_codes_accepted = sanitize($country_codes_accepted, $mysqli);
		$country_codes_not_accepted = sanitize($country_codes_not_accepted, $mysqli);

		// calculate series position (place last)
		$sql = "SELECT * FROM click_rotator_links WHERE click_rotators_id = $click_rotators_id ORDER BY series_position DESC";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
		$count = $result->num_rows;
		if ($count > 0) {
			$row = $result->fetch_array(MYSQLI_BOTH);
			$series_position = $row['series_position'] + 1;
			$result->close();
		} else {
			$series_position = 1;
		}
		
		// save new click_rotator_links record
		$sql = "INSERT INTO click_rotator_links (click_rotators_id, series_position, link_description, link_url, total_clicks_to_send, country_codes_accepted, country_codes_not_accepted, start_date_time, end_date_time, daily_click_limit, click_trades_i_code, notes) values ($click_rotators_id, $series_position, '$link_description', '$link_url', $total_clicks_to_send, '$country_codes_accepted', '$country_codes_not_accepted', '$start_date_time', '$end_date_time', $daily_click_limit, '$click_trades_i_code', '$notes')";		
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not insert record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}

		// stripslashes as needed
		$link_description = stripslashes($link_description);
		$link_url = stripslashes($link_url);
		$click_trades_i_code = stripslashes($click_trades_i_code);
		$notes = stripslashes(str_replace('\r\n', "\n", $notes));
		$country_codes_accepted = stripslashes($country_codes_accepted);
		$country_codes_not_accepted = stripslashes($country_codes_not_accepted);
		
		// prep data as needed for display

		$displaymessage = "New click rotator link has been saved.";		
	}
} else {
	// get click_rotators_id
	$click_rotators_id = $_GET['id'];

	// sanitize data for safety
	$click_rotators_id = sanitize($click_rotators_id, $mysqli);

	// does member own this click rotator?
	$sql = "SELECT * FROM click_rotators WHERE id = $click_rotators_id";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	// bypass hack attempt check
	$count = $result->num_rows;
	if ($count < 1) {
		echo "ERROR: Invalid record ID";
		$mysqli->close();
		exit();
	}
	// get any data needed
	$row = $result->fetch_array(MYSQLI_BOTH);
	$description = stripslashes($row['description']);
	$result->close();

	// clear form field variables
	$link_description = "";
	$link_url = "";
	$total_clicks_to_send = "";
	$click_trades_i_code = "";
	$notes = "";
	$start_date = "";
	$start_hour = "00";
	$start_minute = "00";
	$end_date = "";
	$end_hour = "00";
	$end_minute = "00";
	$country_codes_accepted = "";
	$country_codes_not_accepted = "";
	$daily_click_limit = "";
	
	$displaymessagebox = "n";
	$displaymessage = "";
	$errorcount = 0;
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Add New Rotator Link</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<script language="javascript" src="js/calendar/calendar.js"></script>
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Add New Rotator Link</h1></div><!-- END #page_name -->
	<div id="page_description">
		Enter the information for the new rotator link below.</div><!-- END #page_description -->
	<div id="form_section">

<?php
if ($displaymessagebox == "y") {
	echo "<table>";
	echo "<tr>";
	if ($errorcount > 0) {
		echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
	} else {
		echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
	}
	echo "</tr>";
	echo "</table>";
	echo "<br>";
}
?>

<center>
<form method="post" id="addnewrotatorlink" name="addnewrotatorlink" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">
<input type="hidden" id="click_rotators_id" name="click_rotators_id" value="<?php echo $click_rotators_id; ?>">
<table>
<tr>
<td width="162" class="txtRight bold">Link Description:</td>
<td width="596"><input type="text" id="link_description" name="link_description" size="50" value="<?php echo $link_description; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Link URL:</td>
<td width="596"><input type="text" id="link_url" name="link_url" size="50" value="<?php echo $link_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Total Clicks to Send:</td>
<td width="596"><input type="text" id="total_clicks_to_send" name="total_clicks_to_send" size="5" value="<?php echo $total_clicks_to_send; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Daily Click Limit:</td>
<td width="596"><input type="text" id="daily_click_limit" name="daily_click_limit" size="5" value="<?php echo $daily_click_limit; ?>"></td>
</tr>

<tr>
<td width="162" class="txtRight bold">Start Date:</td>
<td width="596">
<?php
$myCalendar = new tc_calendar(start_date, true);
$myCalendar->setIcon("js/calendar/images/iconCalendar.gif");
$myCalendar->setPath("js/calendar/");
$myCalendar->setYearInterval(2013, 2020);
$myCalendar->dateAllow('2013-01-01', '2020-12-31');
if ($calendar_state == 1) {
	$myCalendar->setDate(date('d', strtotime($start_date)), date('m', strtotime($start_date)), date('Y', strtotime($start_date)));
}
$myCalendar->writeScript();
?>
&nbsp;&nbsp;Hour: <select size="1" name="start_hour">";
<?php
if ($start_hour == "00") {
	echo "<option selected value=\"00\"></option>";
} else {
	echo "<option selected value=\"$start_hour\">$start_hour</option>";
}
?>
<option value="00"></option>
<option value="00">00</option>
<option value="01">01</option>
<option value="02">02</option>
<option value="03">03</option>
<option value="04">04</option>
<option value="05">05</option>
<option value="06">06</option>
<option value="07">07</option>
<option value="08">08</option>
<option value="09">09</option>
<option value="10">10</option>
<option value="11">11</option>
<option value="12">12</option>
<option value="13">13</option>
<option value="14">14</option>
<option value="15">15</option>
<option value="16">16</option>
<option value="17">17</option>
<option value="18">18</option>
<option value="19">19</option>
<option value="20">20</option>
<option value="21">21</option>
<option value="22">22</option>
<option value="23">23</option>
</select>
Minute: <select size="1" name="start_minute">";
<?php
if ($start_minute == "00") {
	echo "<option selected value=\"00\"></option>";
} else {
	echo "<option selected value=\"$start_minute\">$start_minute</option>";
}
?>
<option value="00"></option>
<option value="00">00</option>
<option value="01">01</option>
<option value="02">02</option>
<option value="03">03</option>
<option value="04">04</option>
<option value="05">05</option>
<option value="06">06</option>
<option value="07">07</option>
<option value="08">08</option>
<option value="09">09</option>
<option value="10">10</option>
<option value="11">11</option>
<option value="12">12</option>
<option value="13">13</option>
<option value="14">14</option>
<option value="15">15</option>
<option value="16">16</option>
<option value="17">17</option>
<option value="18">18</option>
<option value="19">19</option>
<option value="20">20</option>
<option value="21">21</option>
<option value="22">22</option>
<option value="23">23</option>
<option value="24">24</option>
<option value="25">25</option>
<option value="26">26</option>
<option value="27">27</option>
<option value="28">28</option>
<option value="29">29</option>
<option value="30">30</option>
<option value="31">31</option>
<option value="32">32</option>
<option value="33">33</option>
<option value="34">34</option>
<option value="35">35</option>
<option value="36">36</option>
<option value="37">37</option>
<option value="38">38</option>
<option value="39">39</option>
<option value="40">40</option>
<option value="41">41</option>
<option value="42">42</option>
<option value="43">43</option>
<option value="44">44</option>
<option value="45">45</option>
<option value="46">46</option>
<option value="47">47</option>
<option value="48">48</option>
<option value="49">49</option>
<option value="50">50</option>
<option value="51">51</option>
<option value="52">52</option>
<option value="53">53</option>
<option value="54">54</option>
<option value="55">55</option>
<option value="56">56</option>
<option value="57">57</option>
<option value="58">58</option>
<option value="59">59</option>
</select>
</td>
</tr>

<tr>
<td width="162" class="txtRight bold">End Date:</td>
<td width="596">
<?php
$myCalendar2 = new tc_calendar(end_date, true);
$myCalendar2->setIcon("js/calendar/images/iconCalendar.gif");
$myCalendar2->setPath("js/calendar/");
$myCalendar2->setYearInterval(2013, 2020);
$myCalendar2->dateAllow('2013-01-01', '2020-12-31');
if ($calendar_state == 1) {
	$myCalendar2->setDate(date('d', strtotime($end_date)), date('m', strtotime($end_date)), date('Y', strtotime($end_date)));
}
$myCalendar2->writeScript();
?>
&nbsp;&nbsp;Hour: <select size="1" name="end_hour">";
<?php
if ($end_hour == "00") {
	echo "<option selected value=\"00\"></option>";
} else {
	echo "<option selected value=\"$end_hour\">$end_hour</option>";
}
?>
<option value="00"></option>
<option value="00">00</option>
<option value="01">01</option>
<option value="02">02</option>
<option value="03">03</option>
<option value="04">04</option>
<option value="05">05</option>
<option value="06">06</option>
<option value="07">07</option>
<option value="08">08</option>
<option value="09">09</option>
<option value="10">10</option>
<option value="11">11</option>
<option value="12">12</option>
<option value="13">13</option>
<option value="14">14</option>
<option value="15">15</option>
<option value="16">16</option>
<option value="17">17</option>
<option value="18">18</option>
<option value="19">19</option>
<option value="20">20</option>
<option value="21">21</option>
<option value="22">22</option>
<option value="23">23</option>
</select>
Minute: <select size="1" name="end_minute">";
<?php
if ($end_minute == "00") {
	echo "<option selected value=\"00\"></option>";
} else {
	echo "<option selected value=\"$end_minute\">$end_minute</option>";
}
?>
<option value="00"></option>
<option value="00">00</option>
<option value="01">01</option>
<option value="02">02</option>
<option value="03">03</option>
<option value="04">04</option>
<option value="05">05</option>
<option value="06">06</option>
<option value="07">07</option>
<option value="08">08</option>
<option value="09">09</option>
<option value="10">10</option>
<option value="11">11</option>
<option value="12">12</option>
<option value="13">13</option>
<option value="14">14</option>
<option value="15">15</option>
<option value="16">16</option>
<option value="17">17</option>
<option value="18">18</option>
<option value="19">19</option>
<option value="20">20</option>
<option value="21">21</option>
<option value="22">22</option>
<option value="23">23</option>
<option value="24">24</option>
<option value="25">25</option>
<option value="26">26</option>
<option value="27">27</option>
<option value="28">28</option>
<option value="29">29</option>
<option value="30">30</option>
<option value="31">31</option>
<option value="32">32</option>
<option value="33">33</option>
<option value="34">34</option>
<option value="35">35</option>
<option value="36">36</option>
<option value="37">37</option>
<option value="38">38</option>
<option value="39">39</option>
<option value="40">40</option>
<option value="41">41</option>
<option value="42">42</option>
<option value="43">43</option>
<option value="44">44</option>
<option value="45">45</option>
<option value="46">46</option>
<option value="47">47</option>
<option value="48">48</option>
<option value="49">49</option>
<option value="50">50</option>
<option value="51">51</option>
<option value="52">52</option>
<option value="53">53</option>
<option value="54">54</option>
<option value="55">55</option>
<option value="56">56</option>
<option value="57">57</option>
<option value="58">58</option>
<option value="59">59</option>
</select>
</td>
</tr>

<tr>
<td width="162" class="txtRight bold">Country Codes Accepted:</td>
<td width="596"><input type="text" id="country_codes_accepted" name="country_codes_accepted" size="50" value="<?php echo $country_codes_accepted; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Country Codes Not Accepted:</td>
<td width="596"><input type="text" id="country_codes_not_accepted" name="country_codes_not_accepted" size="50" value="<?php echo $country_codes_not_accepted; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Click Trade Inbound Code:</td>
<td width="596"><input type="text" id="click_trades_i_code" name="click_trades_i_code" size="20" value="<?php echo $click_trades_i_code; ?>"></td>
</tr>
<tr>
<td valign="top" class="txtRight bold">Notes:</td>
<td><textarea rows="5" name="notes" cols="55"><?php echo $notes; ?></textarea></td>
</tr>
</table>
<br>            
<input type="submit" name="submit" id="submit" value="Add New Rotator Link">
</form>
</center>
<br><br>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
