<?php

// My Click Boss - Version 1.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// was this page called by a form POST to update record or a GET to display record for editing?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	$email = $_POST['email'];
	$password = $_POST['password'];
	$password_again = $_POST['password_again'];
	
	// check fields for errors
	$errorcount = 0;
	$displaymessagebox = "y";
	$displaymessage = "";
	
	// $password and $password_again
	if ($password != "") {
		$password = trim($password);
		$password_again = trim($password_again);
		// does password fields match?
		if (strcmp($password, $password_again) <> 0) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Login Password' and 'Login Repeat Password' fields did not match.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Login Password' and 'Login Repeat Password' fields did not match.";
			}
			$errorcount++;
		}
		if(!preg_match('/^[a-zA-Z0-9]+$/', $password)) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Login Password' field can only contain a-z, 0-9, A-Z.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Login Password' field can only contain a-z, 0-9, A-Z.";
			}
			$errorcount++;
		}
		// check password length
		if (strlen($password) < 6) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Login Password' field must be between 6 and 50 characters.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Login Password' field must be between 6 and 50 characters.";
			}
			$errorcount++;
		}
		if (strlen($password) > 50) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Login Password' field must be between 6 and 50 characters.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Login Password' field must be between 6 and 50 characters.";
			}
			$errorcount++;
		}	
	}

	if ($errorcount == 0) {
		// sanitize data
		$default_url = sanitize($default_url, $mysqli);
		
		// did password change? if so hash it
		if ($password != "") {
			// hash new password and work salt magic
			$password = hash('sha512', $password); 
			// Create a random salt
			$random_salt = hash('sha512', uniqid(mt_rand(1, mt_getrandmax()), true));
			// Create salted password (Careful not to over season)
			$password = hash('sha512', $password.$random_salt);
			
			$sql = "UPDATE members SET password = '$password', salt = '$random_salt' WHERE id = $members_id";
			// update record
			$result = $mysqli->query($sql);
			if ($mysqli->connect_errno) {
				echo "Could not update record in members: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
		} else {
		}	

		$displaymessage = "Login settings have been updated.";
		
		// prepared data for display		
		$password = "";
		$password_again = "";
	}
} else {
	// get script configuration data settings
	$sql = "SELECT * FROM members WHERE id = $members_id";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in members: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	$row = $result->fetch_array(MYSQLI_BOTH);
	$email = stripslashes($row['email']);
	$result->close();

	$password = "";
	$password_again = "";
	$displaymessagebox = "n";
	$displaymessage = "";
	$errorcount = 0;
}
	
// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Change Login</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Change Login</h1></div><!-- END #page_name -->
	<div id="page_description">
		Edit the information below and then click the update button to save the changed login information to the database.</div><!-- END #page_description -->
	<div id="form_section">

<?php
if ($displaymessagebox == "y") {
	echo "<table>";
	echo "<tr>";
	if ($errorcount > 0) {
		echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
	} else {
		echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
	}
	echo "</tr>";
	echo "</table>";
	echo "<br>";
}
?>

<center>
<form method="post" id="editlogin" name="editlogin" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">
<input type="hidden" name="email" value="<?php echo $email; ?>">
<table>
<tr>
<td width="162" class="txtRight bold">Login Email Address:</td>
<td width="596"><?php echo $email; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Login Password:</td>
<td width="596"><input type="password" id="password" name="password" size="50" value=""></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Login Password Again:</td>
<td width="596"><input type="password" id="password_again" name="password_again" size="50" value=""></td>
</tr>
</table>
<br>            
<input type="submit" name="submit" id="submit" value="Update Login Information">
</form>
</center>
<br><br>

	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
