<?php

// My Click Boss - Version 1.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// get rotator id
$click_rotators_id = $_GET['id'];

// sanitize gets
$click_rotators_id = sanitize($click_rotators_id, $mysqli);

// does member own this click rotator?
$sql = "SELECT * FROM click_rotators WHERE id = $click_rotators_id";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
	
// bypass hack attempt check
$count = $result->num_rows;
if ($count < 1) {
	echo "ERROR: Invalid record ID";
	$mysqli->close();
	exit();
}
	
// get the data
$row = $result->fetch_array(MYSQLI_BOTH);
$description = stripslashes($row['description']);
$rotator_type = $row['rotator_type'];
$default_url = stripslashes($row['default_url']);
$rotator_click_tracking_code = $row['rotator_click_tracking_code'];
$result->close();

// create rotator_link to display
$rotator_link = $rotator_url . "?a=" . $rotator_click_tracking_code;

// get links for this rotator
$sql = "SELECT * FROM click_rotator_links WHERE click_rotators_id = $click_rotators_id ORDER BY series_position ASC";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Rotator Links</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Rotator Links</h1></div><!-- END #page_name -->
	<div id="page_description">
		<?php echo $description; ?></div><!-- END #page_description -->
	<div id="form_section">
<center>
<table>
  <tr>
  <td><a href="add-new-rotator-link.php?id=<?php echo $click_rotators_id; ?>">Add New Link</a></td>
  </tr>
</table>
<br><br>
<table>
  <thead>
  <tr>
    <th class="listHeading">Description</th>
    <th class="listHeading">Send</th>
    <th class="listHeading">Sent</th>
    <th class="listHeading">Status</th>
    <th class="listHeading">Edit</th>
    <th class="listHeading">Move</th>
    <th class="listHeading">Reset</th>		
    <th class="listHeading">Delete</th>		
  </tr>
  </thead>
  <tbody>
<?php
while ($row = $result->fetch_array(MYSQLI_BOTH)) {
	$click_rotator_links_id = $row['id'];
	$series_position = $row['series_position'];
	$link_description = stripslashes($row['link_description']);
	$link_url = stripslashes($row['link_url']);
	$total_clicks_to_send = $row['total_clicks_to_send'];
	$total_clicks_sent = $row['total_clicks_sent'];
	$date_last_click_sent = $row['date_last_click_sent'];
	$country_codes_accepted = $row['country_codes_accepted'];
	$link_status = $row['link_status'];
	
	echo "<tr>";
	echo "<td>";
	echo "<a href=\"$link_url\">$link_description</a>";
	echo "</td>";
	echo "<td>";
	echo "$total_clicks_to_send";
	echo "</td>";
	echo "<td>";
	echo "$total_clicks_sent";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"rotator-link-status.php?id=$click_rotator_links_id&status=$link_status&rid=$click_rotators_id\">$link_status</a>";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"edit-rotator-link.php?id=$click_rotator_links_id\">Edit</a>";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"move-rotator-link-up.php?id=$click_rotator_links_id\">Up</a>/<a href=\"move-rotator-link-down.php?id=$click_rotator_links_id\">Dn</a>";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"reset-rotator-link.php?id=$click_rotator_links_id\" onclick=\"return confirm('Are you sure you want to reset this link?')\">Reset</a>";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"delete-rotator-link.php?id=$click_rotator_links_id\" onclick=\"return confirm('Are you sure you want to delete this link?')\">Delete</a>";
	echo "</td>";
	echo "</tr>";
} // end while
?>
  </tbody>
</table>
<br><br>
</center>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
