<?php

// My Click Boss - Version 3.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// was this page called by a form POST?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	// get form fields
	$id = $_POST['id'];
	$click_tracker_type = $_POST['click_tracker_type'];
	$description = $_POST['description'];
	$url = $_POST['url'];
	$maximum_clicks = $_POST['maximum_clicks'];
	$secondary_url = $_POST['secondary_url'];
	$notes = $_POST['notes'];
	$country_codes_accepted = $_POST['country_codes_accepted'];
	$country_codes_not_accepted = $_POST['country_codes_not_accepted'];
	$stats_password = $_POST['stats_password'];
	$alert_when_number_clicks_sent = $_POST['alert_when_number_clicks_sent'];

	$displaymessagebox = "y";

	// check fields for errors
	$errorcount = 0;
	$displaymessage = "";

	// $description
	$description = trim($description);
	if ($description == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($description) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $url
	$url = trim($url);
	if ($url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'My URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'My URL' field can't be blank.";
		}
		$errorcount++;
	}	

	// $maximum_clicks
	if ($maximum_clicks == "") {
		$maximum_clicks = 0;
	}
	// is maximum_clicks an integer?
	if(!preg_match('/^[0-9]+$/', $maximum_clicks)) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($maximum_clicks < 0) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($maximum_clicks > 999999999) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}

	// $alert_when_number_clicks_sent
	if ($alert_when_number_clicks_sent == "") {
		$alert_when_number_clicks_sent = 0;
	}
	// is alert_when_number_clicks_sent an integer?
	if(!preg_match('/^[0-9]+$/', $alert_when_number_clicks_sent)) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($alert_when_number_clicks_sent < 0) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($alert_when_number_clicks_sent > 999999999) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	
	// $stats_password
	$stats_password = trim($stats_password);
	if (strlen($stats_password) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Stats Password' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Stats Password' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	
	// process if no errors
	if ($errorcount == 0) {		
		// sanitize data as needed
		$id = sanitize($id, $mysqli);
		$description = sanitize($description, $mysqli);
		$url = sanitize($url, $mysqli);
		$secondary_url = sanitize($secondary_url, $mysqli);
		$notes = sanitize($notes, $mysqli);
		$country_codes_accepted = sanitize($country_codes_accepted, $mysqli);
		$country_codes_not_accepted = sanitize($country_codes_not_accepted, $mysqli);
		$stats_password = sanitize($stats_password, $mysqli);
		
		// get click_trackers record
		$sql = "SELECT * FROM click_trackers WHERE id = $id && tracker_status = 'Active'";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
	
		// bypass hack attempt check
		$count = $result->num_rows;
		if ($count < 1) {
			echo "ERROR: Invalid record ID";
			$mysqli->close();
			exit();
		}
	
		// get the data
		$row = $result->fetch_array(MYSQLI_BOTH);
		$date_click_tracker_created = $row['date_click_tracker_created'];
		$click_tracking_code = $row['click_tracking_code'];
		$total_clicks = $row['total_clicks'];
		$result->close();

		if ($alert_when_number_clicks_sent > $total_clicks_sent) {
			$email_alert_sent = "No";
		} else {
			$email_alert_sent = "Yes";		
		}
		
		// UPDATE click_trackers record
		$sql = "UPDATE click_trackers SET description = '$description', click_tracker_type = '$click_tracker_type', url = '$url', maximum_clicks = $maximum_clicks, secondary_url = '$secondary_url', country_codes_accepted = '$country_codes_accepted', country_codes_not_accepted = '$country_codes_not_accepted', stats_password = '$stats_password', alert_when_number_clicks_sent = $alert_when_number_clicks_sent, email_alert_sent = '$email_alert_sent', notes = '$notes' WHERE id = $id";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not update record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}

		// stripslashes as needed
		$description = stripslashes($description);
		$url = stripslashes($url);
		$secondary_url = stripslashes($secondary_url);
		$notes = stripslashes(str_replace('\r\n', "\n", $notes));
		$country_codes_accepted = stripslashes($country_codes_accepted);
		$country_codes_not_accepted = stripslashes($country_codes_not_accepted);
		$stats_password = stripslashes($stats_password);

		// create click tracking url to display
		$click_tracking_url = $tracker_url . "?a=" . $click_tracking_code;

		// create pixel url to display
		$pixel_tracking_code = "<img src='" . $pixel_tracker_url . "?ptl=main' width='1' height='1'>";

		// create stats url
		$stats_link = $stats_url . "?i=" . $id . "&p=" . $stats_password;
		
		// prep data as needed for display

		$displaymessage = "Click tracker has been updated.";		
	}
} else {
	// get $_GET
	$id = $_GET['id'];

	// sanitize gets
	$id = sanitize($id, $mysqli);
	
	// get click_trackers record
	$sql = "SELECT * FROM click_trackers WHERE id = $id && tracker_status = 'Active'";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	
	// bypass hack attempt check
	$count = $result->num_rows;
	if ($count < 1) {
		echo "ERROR: Invalid record ID";
		$mysqli->close();
		exit();
	}
	
	// get the data
	$row = $result->fetch_array(MYSQLI_BOTH);
	$description = stripslashes($row['description']);
	$click_tracker_type = $row['click_tracker_type'];
	$url = stripslashes($row['url']);
	$maximum_clicks = $row['maximum_clicks'];
	$secondary_url = stripslashes($row['secondary_url']);
	$date_click_tracker_created = $row['date_click_tracker_created'];
	$click_tracking_code = $row['click_tracking_code'];
	$total_clicks = $row['total_clicks'];
	$country_codes_accepted = stripslashes($row['country_codes_accepted']);
	$country_codes_not_accepted = stripslashes($row['country_codes_not_accepted']);
	$notes = stripslashes($row['notes']);
	$stats_password = stripslashes($row['stats_password']);
	$alert_when_number_clicks_sent = $row['alert_when_number_clicks_sent'];
	$result->close();

	// create click tracking url to display
	$click_tracking_url = $tracker_url . "?a=" . $click_tracking_code;

	// create pixel url to display
	$pixel_tracking_code = "<img src='" . $pixel_tracker_url . "?ptl=main' width='1' height='1'>";

	// create stats url
	$stats_link = $stats_url . "?i=" . $id . "&p=" . $stats_password;
	
	$displaymessagebox = "n";
	$displaymessage = "";
	$errorcount = 0;
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Edit Click Tracker</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Edit Click Tracker</h1></div><!-- END #page_name -->
	<div id="page_description">
		Edit the information below as desired.</div><!-- END #page_description -->
	<div id="form_section">

<?php
if ($displaymessagebox == "y") {
	echo "<table>";
	echo "<tr>";
	if ($errorcount > 0) {
		echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
	} else {
		echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
	}
	echo "</tr>";
	echo "</table>";
	echo "<br>";
}
?>

<center>
<form method="post" id="editclicktracker" name="editclicktracker" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>">
<table>

<tr>
<td width="162" class="txtRight bold">Description:</td>
<td width="596"><input type="text" id="description" name="description" size="50" value="<?php echo $description; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Type:</td>
<td width="596">
<select size="1" id="click_tracker_type" name="click_tracker_type">
<?php
	switch($click_tracker_type) {
		case "I":
	      	echo "<option value=\"\"></option>";
	      	echo "<option selected value=\"I\">Inbound</option>";
	      	echo "<option value=\"O\">Outbound</option>";
			break;
		case "O":
	      	echo "<option value=\"\"></option>";
	      	echo "<option value=\"I\">Inbound</option>";
	      	echo "<option selected value=\"O\">Outbound</option>";
			break;
		default:
	      	echo "<option selected value=\"\"></option>";
	      	echo "<option value=\"I\">Inbound</option>";
	      	echo "<option value=\"O\">Outbound</option>";
			break;
	}
?>
</select>
</td>
</tr>
<tr>
<td width="162" class="txtRight bold">URL:</td>
<td width="596"><input type="text" id="url" name="url" size="50" value="<?php echo $url; ?>"></td>
</tr>

<tr>
<td width="162" class="txtRight bold">Maximum Clicks:</td>
<td width="596"><input type="text" id="maximum_clicks" name="maximum_clicks" size="10" value="<?php echo $maximum_clicks; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Sent Click Count Alert:</td>
<td width="596"><input type="text" id="alert_when_number_clicks_sent" name="alert_when_number_clicks_sent" size="5" value="<?php echo $alert_when_number_clicks_sent; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Country Codes Accepted:</td>
<td width="596"><input type="text" id="country_codes_accepted" name="country_codes_accepted" size="50" value="<?php echo $country_codes_accepted; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Country Codes Not Accepted:</td>
<td width="596"><input type="text" id="country_codes_not_accepted" name="country_codes_not_accepted" size="50" value="<?php echo $country_codes_not_accepted; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Secondary URL:</td>
<td width="596"><input type="text" id="secondary_url" name="secondary_url" size="50" value="<?php echo $secondary_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Stats Password:</td>
<td width="596"><input type="text" id="stats_password" name="stats_password" size="50" value="<?php echo $stats_password; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Click Tracking Link:</td>
<td width="596"><input type="text" id="click_tracking_url" name="click_tracking_url" size="75" value="<?php echo $click_tracking_url; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Pixel Code:</td>
<td width="596"><input type="text" id="pixel_tracking_code" name="pixel_tracking_code" size="75" value="<?php echo $pixel_tracking_code; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Stats Link:</td>
<td width="596"><input type="text" id="stats_link" name="stats_link" size="75" value="<?php echo $stats_link; ?>" readonly></td>
</tr>

<tr>
<td width="162" class="txtRight bold">Date Created:</td>
<td width="596"><?php echo $date_click_tracker_created; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Total Clicks:</td>
<td width="596"><?php echo $total_clicks; ?></td>
</tr>

<tr>
<td valign="top" class="txtRight bold">Notes:</td>
<td><textarea rows="5" name="notes" cols="55"><?php echo $notes; ?></textarea></td>
</tr>
</table>
<br>            
<input type="submit" name="submit" id="submit" value="Update Click Tracker">
</form>
</center>
<br><br>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
