<?php

// My Click Boss - Version 2.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// was this page called by a form POST?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	// get form fields
	$id = $_POST['id'];
	$description = $_POST['description'];
	$trade_partners_url = $_POST['trade_partners_url'];
	$my_url = $_POST['my_url'];
	$trade_partners_stats_password = $_POST['trade_partners_stats_password'];
	$notes = $_POST['notes'];
	$alert_when_number_clicks_sent = $_POST['alert_when_number_clicks_sent'];

	$displaymessagebox = "y";

	// check fields for errors
	$errorcount = 0;
	$displaymessage = "";

	// $description
	$description = trim($description);
	if ($description == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($description) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $trade_partners_url
	$trade_partners_url = trim($trade_partners_url);
	if ($trade_partners_url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Trade Partners URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Trade Partners URL' field can't be blank.";
		}
		$errorcount++;
	}	
	// $my_url
	$my_url = trim($my_url);
	if ($my_url == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'My URL' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'My URL' field can't be blank.";
		}
		$errorcount++;
	}	
	// $trade_partners_stats_password
	$trade_partners_stats_password = trim($trade_partners_stats_password);
	if ($trade_partners_stats_password == "") {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Trade Partners Stats Password' field can't be blank.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Trade Partners Stats Password' field can't be blank.";
		}
		$errorcount++;
	}
	if (strlen($trade_partners_stats_password) > 255) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Trade Partners Stats Password' field must be a maximum of 255 characters.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Trade Partners Stats Password' field must be a maximum of 255 characters.";
		}
		$errorcount++;
	}
	// $alert_when_number_clicks_sent
	if ($alert_when_number_clicks_sent == "") {
		$alert_when_number_clicks_sent = 0;
	}
	// is alert_when_number_clicks_sent an integer?
	if(!preg_match('/^[0-9]+$/', $alert_when_number_clicks_sent)) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($alert_when_number_clicks_sent < 0) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	if ($alert_when_number_clicks_sent > 999999999) {
		if ($displaymessage == "") {
			$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		} else {
			$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
		}
		$errorcount++;
	}
	
	// process if no errors
	if ($errorcount == 0) {		
		// sanitize data as needed
		$id = sanitize($id, $mysqli);
		$description = sanitize($description, $mysqli);
		$trade_partners_url = sanitize($trade_partners_url, $mysqli);
		$my_url = sanitize($my_url, $mysqli);
		$trade_partners_stats_password = sanitize($trade_partners_stats_password, $mysqli);
		$notes = sanitize($notes, $mysqli);

		// get click_trades record
		$sql = "SELECT * FROM click_trades WHERE id = $id && trade_status = 'Active'";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
	
		// bypass hack attempt check
		$count = $result->num_rows;
		if ($count < 1) {
			echo "ERROR: Invalid record ID";
			$mysqli->close();
			exit();
		}
	
		// get the data
		$row = $result->fetch_array(MYSQLI_BOTH);
		$date_click_trade_created = $row['date_click_trade_created'];
		$inbound_click_tracking_code = $row['inbound_click_tracking_code'];
		$outbound_click_tracking_code = $row['outbound_click_tracking_code'];
		$total_clicks_received = $row['total_clicks_received'];
		$total_clicks_sent = $row['total_clicks_sent'];
		$result->close();

		if ($alert_when_number_clicks_sent > $total_clicks_sent) {
			$email_alert_sent = "No";
		} else {
			$email_alert_sent = "Yes";		
		}
		
		// UPDATE click_trades record
		$sql = "UPDATE click_trades SET description = '$description', trade_partners_url = '$trade_partners_url', my_url = '$my_url', alert_when_number_clicks_sent = $alert_when_number_clicks_sent, email_alert_sent = '$email_alert_sent', trade_partners_stats_password = '$trade_partners_stats_password', notes = '$notes' WHERE id = $id";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not update record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}

		// stripslashes as needed
		$description = stripslashes($description);
		$trade_partners_url = stripslashes($trade_partners_url);
		$my_url = stripslashes($my_url);
		$trade_partners_stats_password = stripslashes($trade_partners_stats_password);
		$notes = stripslashes(str_replace('\r\n', "\n", $notes));

		// create click tracking urls to display
		$inbound_click_tracking_url = $trades_url . "?a=" . $inbound_click_tracking_code;
		$outbound_click_tracking_url = $trades_url . "?a=" . $outbound_click_tracking_code;

		// create pixel url to display
		$pixel_tracking_code = "<img src='" . $pixel_tracker_url . "?ptl=main' width='1' height='1'>";
		
		// create trade stats url
		$stats_link = $trade_stats_url . "?i=" . $id . "&p=" . $trade_partners_stats_password;
		
		// prep data as needed for display

		$displaymessage = "Click trade has been updated.";		
	}
} else {
	// get $_GET
	$id = $_GET['id'];

	// sanitize gets
	$id = sanitize($id, $mysqli);

	// get click_trades record
	$sql = "SELECT * FROM click_trades WHERE id = $id && trade_status = 'Active'";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_trades: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	
	// bypass hack attempt check
	$count = $result->num_rows;
	if ($count < 1) {
		echo "ERROR: Invalid record ID";
		$mysqli->close();
		exit();
	}
	
	// get the data
	$row = $result->fetch_array(MYSQLI_BOTH);
	$description = stripslashes($row['description']);
	$trade_partners_url = stripslashes($row['trade_partners_url']);
	$my_url = stripslashes($row['my_url']);
	$date_click_trade_created = $row['date_click_trade_created'];
	$inbound_click_tracking_code = $row['inbound_click_tracking_code'];
	$outbound_click_tracking_code = $row['outbound_click_tracking_code'];
	$total_clicks_received = $row['total_clicks_received'];
	$total_clicks_sent = $row['total_clicks_sent'];
	$alert_when_number_clicks_sent = $row['alert_when_number_clicks_sent'];
	$trade_partners_stats_password = stripslashes($row['trade_partners_stats_password']);
	$notes = stripslashes($row['notes']);
	$result->close();

	// create click tracking urls to display
	$inbound_click_tracking_url = $trades_url . "?a=" . $inbound_click_tracking_code;
	$outbound_click_tracking_url = $trades_url . "?a=" . $outbound_click_tracking_code;

	// create pixel url to display
	$pixel_tracking_code = "<img src='" . $pixel_tracker_url . "?ptl=main' width='1' height='1'>";
		
	// create trade stats url
	$stats_link = $trade_stats_url . "?i=" . $id . "&p=" . $trade_partners_stats_password;

	$displaymessagebox = "n";
	$displaymessage = "";
	$errorcount = 0;
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Edit Click Trade</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Edit Click Trade</h1></div><!-- END #page_name -->
	<div id="page_description">
		Edit the information below as desired.</div><!-- END #page_description -->
	<div id="form_section">

<?php
if ($displaymessagebox == "y") {
	echo "<table>";
	echo "<tr>";
	if ($errorcount > 0) {
		echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
	} else {
		echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
	}
	echo "</tr>";
	echo "</table>";
	echo "<br>";
}
?>

<center>
<form method="post" id="editclicktrade" name="editclicktrade" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>">
<table>

<tr>
<td width="162" class="txtRight bold">Description:</td>
<td width="596"><input type="text" id="description" name="description" size="50" value="<?php echo $description; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Trade Partners Stats Password:</td>
<td width="596"><input type="text" id="trade_partners_stats_password" name="trade_partners_stats_password" size="50" value="<?php echo $trade_partners_stats_password; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Trade Partners Click URL:</td>
<td width="596"><input type="text" id="trade_partners_url" name="trade_partners_url" size="50" value="<?php echo $trade_partners_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">My Click URL:</td>
<td width="596"><input type="text" id="my_url" name="my_url" size="50" value="<?php echo $my_url; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Sent Click Count Alert:</td>
<td width="596"><input type="text" id="alert_when_number_clicks_sent" name="alert_when_number_clicks_sent" size="5" value="<?php echo $alert_when_number_clicks_sent; ?>"></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Inbound Click Tracking Link:</td>
<td width="596"><input type="text" id="inbound_click_tracking_url" name="inbound_click_tracking_url" size="75" value="<?php echo $inbound_click_tracking_url; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Outbound Click Tracking Link:</td>
<td width="596"><input type="text" id="outbound_click_tracking_url" name="outbound_click_tracking_url" size="75" value="<?php echo $outbound_click_tracking_url; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Pixel Code:</td>
<td width="596"><input type="text" id="pixel_tracking_code" name="pixel_tracking_code" size="75" value="<?php echo $pixel_tracking_code; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Partner Stats URL:</td>
<td width="596"><input type="text" id="stats_link" name="stats_link" size="75" value="<?php echo $stats_link; ?>" readonly></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Date Created:</td>
<td width="596"><?php echo $date_click_trade_created; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Inbound Clicks Received:</td>
<td width="596"><?php echo $total_clicks_received; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Outbound Clicks Sent:</td>
<td width="596"><?php echo $total_clicks_sent; ?></td>
</tr>
<tr>
<td valign="top" class="txtRight bold">Notes:</td>
<td><textarea rows="5" name="notes" cols="55"><?php echo $notes; ?></textarea></td>
</tr>
</table>
<br>            
<input type="submit" name="submit" id="submit" value="Update Click Trade">
</form>
</center>
<br><br>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
