<?php

// My Click Boss - Version 3.1
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// get form POST fields
$export_records = $_POST['export_records']; // All, Unique, RawOnly
$file_format = $_POST['file_format']; // CSV, TABDELIMITED
$inbound_outbound = $_POST['inbound_outbound']; // i,o
$click_trades_id = $_POST['id'];

// open export file for writing
$exportfile = "export-file.txt";
$fh = fopen($exportfile, 'w');

// write header
if ($file_format == "CSV") {
	$fields = array("Click Date", "IP Address", "Referring URL", "Country Code", "Country Name", "Browser Language Code", "User Agent", "IP Host");
	fputcsv($fh, $fields);
} else {
	$line = "Click Date\tIP Address\tReferring URL\tCountry Code\tCountry Name\tBrowser Language Code\tUser Agent\tIP Host\r\n";
	fwrite($fh, $line);
}

// get unique records if selected
if ($export_records == "Unique" || $export_records == "All") {
	$sql = "SELECT * FROM click_trade_stats WHERE click_trades_id = $click_trades_id && inbound_outbound = '$inbound_outbound'";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_trade_stats: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}	
	while ($row = $result->fetch_array(MYSQLI_BOTH)) {
		$click_date = $row['click_date'];
		$surfer_ip = stripslashes($row['surfer_ip']);
		$referring_url = stripslashes($row['referring_url']);
		$country_code = stripslashes($row['country_code']);
		$country_name = stripslashes($row['country_name']);
		$language_code = stripslashes($row['language_code']);
		$user_agent = stripslashes($row['user_agent']);
		$ip_host = stripslashes($row['ip_host']);
		switch ($file_format) {
			case "CSV":			
				$fields = array($click_date, $surfer_ip, $referring_url, $country_code, $country_name, $language_code, $user_agent, $ip_host);
				fputcsv($fh, $fields);
				break;
			case "TABDELIMITED":
				$line = $click_date . "\t" . $surfer_ip . "\t" . $referring_url . "\t" . $country_code . "\t" . $country_name . "\t" . $language_code . "\t" . $user_agent . "\t" . $ip_host . "\r\n";
				fwrite($fh, $line);
				break;
		} // end switch
	}
}

// get raw records if selected
if ($export_records == "RawOnly" || $export_records == "All") {
	$sql = "SELECT * FROM click_trade_raw_stats WHERE click_trades_id = $click_trades_id && inbound_outbound = '$inbound_outbound'";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_trade_raw_stats: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}	
	while ($row = $result->fetch_array(MYSQLI_BOTH)) {
		$click_date = $row['click_date'];
		$surfer_ip = stripslashes($row['surfer_ip']);
		$referring_url = stripslashes($row['referring_url']);
		$country_code = stripslashes($row['country_code']);
		$country_name = stripslashes($row['country_name']);
		$language_code = stripslashes($row['language_code']);
		$user_agent = stripslashes($row['user_agent']);
		$ip_host = stripslashes($row['ip_host']);
		switch ($file_format) {
			case "CSV":			
				$fields = array($click_date, $surfer_ip, $referring_url, $country_code, $country_name, $language_code, $user_agent, $ip_host);
				fputcsv($fh, $fields);
				break;
			case "TABDELIMITED":
				$line = $click_date . "\t" . $surfer_ip . "\t" . $referring_url . "\t" . $country_code . "\t" . $country_name . "\t" . $language_code . "\t" . $user_agent . "\t" . $ip_host . "\r\n";
				fwrite($fh, $line);
				break;
		} // end switch
	}
}

// close export file
fclose($fh);

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Export Trade</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Export Trade</h1></div><!-- END #page_name -->
	<div id="page_description">Right click to download and save the export file. Make sure you click on "Erase Export File" once you have downloaded it for security reasons.</div><!-- END #page_description -->
	<div id="form_section">
<table>
<tr>
<td width="162" class="txtRight bold">Export File:</td>
<td width="596"><a href="export-file.txt">right click to save</a></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Erase Export File:</td>
<td width="596"><a href="erase-export-file.php">click here to erase</a></td>
</tr>
</table>
<br>            
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
