<?php

// My Click Boss - Version 1.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// number of records to display per page
$records_per_page = 25;

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// was this page called by a form search POST or a GET?
$method = $_SERVER['REQUEST_METHOD'];
if ($method == 'POST') {
	$search_value = sanitize($_POST['search_value'], $mysqli);
	$page_number = 1;
} else {
	// get requested page number and search variable if set
	$page_number = $_GET['page'];
	$search_value = $_GET['search'];
	if(!(isset($page_number))) {
		$page_number = 1;
	}
	if(!(isset($search_value))) {
		$search_value = "";
	}
}

// calculate first record number to display on page
$start_record = ($page_number - 1) * $records_per_page;

if ($search_value != "") {
	// get click_rotators that match search criteria
	$search_value2 = "%" . $search_value . "%";
	$sql = "SELECT * FROM click_rotators WHERE (description LIKE '$search_value2' || notes LIKE '$search_value2') ORDER BY description ASC LIMIT $start_record, $records_per_page";
} else {
	// get all click_rotators
	$sql = "SELECT * FROM click_rotators ORDER BY description ASC LIMIT $start_record, $records_per_page";
}

$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// calculate number of pages (consider search if search field is not blank)
if ($search_value != "") {
	$sql2 = "SELECT * FROM click_rotators WHERE (description LIKE '$search_value2' || notes LIKE '$search_value2')";
} else {
	// get all click_rotators
	$sql2 = "SELECT * FROM click_rotators";
}
$result2 = $mysqli->query($sql2);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$count2 = $result2->num_rows;
$total_pages = ceil($count2 / $records_per_page);
$result2->close();

// assign Previous page number
if ($page_number > 1) {
	$pagenum = $page_number - 1;
	if ($search_value != "") {
		$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum . "&search=" . urlencode($search_value);
	} else {
		$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum;
	}
	$nav = "<a href=\"$nav_url\">Previous</a>" . " ";
} else {
	$nav = "Previous ";
}

// calculate and assign 4 below pages
if ($page_number > 1) {
	$i = $page_number - 1;
	if ($i > 4) {
		$i = 4;
	}
	for ($ii = $page_number - $i; $ii <= $page_number - 1; $ii++) {
		$pagenum = $ii;
		if ($search_value != "") {
			$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum . "&search=" . urlencode($search_value);
		} else {
			$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum;
		}
		$nav .= "<a href=\"$nav_url\">$pagenum</a>" . " ";		
	}
}

// current page not clickable
$nav .= $page_number . " ";

// calculate and assign 5 above pages
if ($total_pages > $page_number) {
	$i = $total_pages - $page_number;
	if ($i > 5) {
		$i = 5;
	}
	for ($ii = 1; $ii <= $i; $ii++) {
		$pagenum = $page_number + $ii;
		if ($search_value != "") {
			$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum . "&search=" . urlencode($search_value);
		} else {
			$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum;
		}
		$nav .= "<a href=\"$nav_url\">$pagenum</a>" . " ";		
	}
}

// assign Next page number
if ($page_number < $total_pages) {
	$pagenum = $page_number + 1;
	if ($search_value != "") {
		$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum . "&search=" . urlencode($search_value);
	} else {
		$nav_url = $_SERVER['SCRIPT_NAME'] . "?page=" . $pagenum;
	}
	$nav .= "<a href=\"$nav_url\">Next</a>";
} else {
	$nav .= "Next";
}

// close up shop
$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Click Rotators</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>My Click Rotators</h1></div><!-- END #page_name -->
	<div id="page_description">
		Below is a list of all of your click rotators in My Click Boss.</div><!-- END #page_description -->
	<div id="form_section">

<center>
<table>
  <tr>
    <td><form method="post" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>">Search: <input type="text" name="search_value" size="30" value=""> <input type="submit" value="Search"></form></td>
<td width="50"><a href="add-new-click-rotator.php">New</a></td>
  </tr>
</table>
<br><br>
<table>
  <thead>
  <tr>
    <th class="listHeading">Description</th>
    <th class="listHeading">Type</th>
    <th class="listHeading">Links</th>
    <th class="listHeading">Stats</th>
    <th class="listHeading">Delete</th>	
  </tr>
  </thead>
  <tbody>
<?php
while ($row = $result->fetch_array(MYSQLI_BOTH)) {
	$id = $row['id'];
	$description = stripslashes($row['description']);
	$rotator_type = $row['rotator_type'];
	
	echo "<tr>";
	echo "<td>";
	echo "<a href=\"edit-click-rotator.php?id=$id\">$description</a>";
	echo "</td>";
	echo "<td>";
	echo "$rotator_type";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"click-rotator-links.php?id=$id\">Links</a>";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"click-rotator-stats.php?id=$id\">Stats</a>";
	echo "</td>";
	echo "<td>";
	echo "<a href=\"delete-click-rotator.php?id=$id\" onclick=\"return confirm('Are you sure you want to delete this click rotator?')\">Delete</a>";
	echo "</td>";
	echo "</tr>";
} // end while
?>
  </tbody>
</table>
<br><br>
<table>
  <tr>
    <td><?php echo $nav; ?></td>
  </tr>
</table>
</center>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
