<?php

// My Click Boss - Version 3.1
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// is this a qualified API call?
// ?f=function&p=password&s=securitycode

// how was this form called?
$method = $_SERVER['REQUEST_METHOD'];
switch ($method) {
	case "POST":
		// get POST data
		if (isset($_POST['f'])) {
			$mcb_function_call = $_POST['f'];
		} else {
			$mcb_function_call = "";
		}
		if (isset($_POST['p'])) {
			$mcb_password = $_POST['p'];
		} else {
			$mcb_password = "";
		}
		if (isset($_POST['s'])) {
			$mcb_security_code = $_POST['s'];
		} else {
			$mcb_security_code = "";
		}
		break;
	case "GET":
		// get GET data
		if (isset($GET['f'])) {
			$mcb_function_call = $GET['f'];
		} else {
			$mcb_function_call = "";
		}
		if (isset($GET['p'])) {
			$mcb_password = $GET['p'];
		} else {
			$mcb_password = "";
		}
		if (isset($GET['s'])) {
			$mcb_security_code = $GET['s'];
		} else {
			$mcb_security_code = "";
		}
		break;
	default:
		$mcb_function_call = "";
		$mcb_password = "";
		$mcb_security_code = "";
		break;
} 

if ($mcb_function_call == "" || $mcb_password == "" || $mcb_security_code == "") {
	exit;
}

// is password and security code valid?
if ($mcb_password != $api_password || $mcb_security_code != $api_security_code) {
	exit;
}

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

switch ($mcb_function_call) {
	case "rlist":
		// return list of available rotators
		// get click_rotators
		$sql = "SELECT * FROM click_rotators";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
		$rotator_list = "";
		while ($row = $result->fetch_array(MYSQLI_BOTH)) {
			$rotator_id = $row['id'];
			$rotator_description = stripslashes($row['description']);
			$rotator_list .= $rotator_id . "\t" . $rotator_description . "\n";
		}		
		$result->close();
		$rotator_list = rtrim($rotator_list, "\n");
		echo $rotator_list;
		break;
	case "addtracker":
		// get additional form fields
		$description = $_POST['description'];
		$click_tracker_type = $_POST['click_tracker_type'];
		$url = $_POST['url'];
		$maximum_clicks = $_POST['maximum_clicks'];
		$secondary_url = $_POST['secondary_url'];
		$click_tracking_code = $_POST['click_tracking_code']; // if blank generate random code
		$notes = $_POST['notes'];
		$country_codes_accepted = $_POST['country_codes_accepted'];
		$country_codes_not_accepted = $_POST['country_codes_not_accepted'];
		$stats_password = $_POST['stats_password'];
		$add_to_rotator = $_POST['add_to_rotator'];
		$rotator_clicks_to_send = $_POST['rotator_clicks_to_send'];
		$alert_when_number_clicks_sent = $_POST['alert_when_number_clicks_sent'];
		// prep any variables
		$click_tracking_code = strtolower($click_tracking_code);
		if ($rotator_clicks_to_send == "") {
			$rotator_clicks_to_send = 0;
		}
		// check fields for errors
		$errorcount = 0;
		$displaymessage = "";
		// $description
		$description = trim($description);
		if ($description == "") {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Description' field can't be blank.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field can't be blank.";
			}
			$errorcount++;
		}
		if (strlen($description) > 255) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Description' field must be a maximum of 255 characters.";
			}
			$errorcount++;
		}
		// $url
		$url = trim($url);
		if ($url == "") {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'URL' field can't be blank.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'URL' field can't be blank.";
			}
			$errorcount++;
		}	
		// $maximum_clicks
		if ($maximum_clicks == "") {
			$maximum_clicks = 0;
		}
		// is maximum_clicks an integer?
		if(!preg_match('/^[0-9]+$/', $maximum_clicks)) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		if ($maximum_clicks < 0) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		if ($maximum_clicks > 999999999) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Maximum Clicks to Send' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		// $alert_when_number_clicks_sent
		if ($alert_when_number_clicks_sent == "") {
			$alert_when_number_clicks_sent = 0;
		}
		// is alert_when_number_clicks_sent an integer?
		if(!preg_match('/^[0-9]+$/', $alert_when_number_clicks_sent)) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		if ($alert_when_number_clicks_sent < 0) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		if ($alert_when_number_clicks_sent > 999999999) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Sent Click Count Alert' field must be a number between 0 and 999999999.";
			}
			$errorcount++;
		}
		// $click_tracking_code if blank generate random code (if not blank, must be valid to include in a url and not in database)
		$click_tracking_code = trim($click_tracking_code);
		if ($click_tracking_code != "") {
			if(!preg_match('/^[a-z0-9-]+$/', $click_tracking_code)) {
				if ($displaymessage == "") {
					$displaymessage = "INPUT ERROR! - The 'Tracker Code' field can only contain a-z, 0-9 and -.";
				} else {
					$displaymessage .= "<br>" . "INPUT ERROR! - The 'Tracker Code' field can only contain a-z, 0-9 and -.";
				}
				$errorcount++;
			}
		}
		if (strlen($click_tracking_code) > 254) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Tracker Code' field must be a maximum of 255 characters.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Tracker Code' field must be a maximum of 255 characters.";
			}
			$errorcount++;
		}
		// make sure if click_tracking_code is not blank it is unique
		if ($click_tracking_code != "") {
			$sql_tc = "SELECT * FROM click_trackers WHERE click_tracking_code = '$click_tracking_code'";
			$result_tc = $mysqli->query($sql_tc);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			$count_tc = $result_tc->num_rows;
			$result_tc->close();
			if ($count_tc > 0) {
				if ($displaymessage == "") {
					$displaymessage = "INPUT ERROR! - The 'Tracker Code' is already in the database and can't be used.";
				} else {
					$displaymessage .= "<br>" . "INPUT ERROR! - The 'Tracker Code' is already in the database and can't be used.";
				}
				$errorcount++;
			}
		}
		// $stats_password
		$stats_password = trim($stats_password);
		if (strlen($stats_password) > 255) {
			if ($displaymessage == "") {
				$displaymessage = "INPUT ERROR! - The 'Stats Password' field must be a maximum of 255 characters.";
			} else {
				$displaymessage .= "<br>" . "INPUT ERROR! - The 'Stats Password' field must be a maximum of 255 characters.";
			}
			$errorcount++;
		}
		// rotator_clicks_to_send
		if ($add_to_rotator > 0) {
			if(!preg_match('/^[0-9]+$/', $rotator_clicks_to_send)) {
				if ($displaymessage == "") {
					$displaymessage = "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
				} else {
					$displaymessage .= "<br>" . "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
				}
				$errorcount++;
			}
			if ($rotator_clicks_to_send < 0) {
				if ($displaymessage == "") {
					$displaymessage = "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
				} else {
					$displaymessage .= "<br>" . "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
				}
				$errorcount++;
			}
			if ($rotator_clicks_to_send > 999999999) {
				if ($displaymessage == "") {
					$displaymessage = "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
				} else {
					$displaymessage .= "<br>" . "INPUT ERROR! - The 'Clicks to Send (Rotator)' field must be a number between 0 and 999999999.";
				}
				$errorcount++;
			}	
		}
		// process if no errors
		if ($errorcount == 0) {
			// generate unique click_tracking_code (append t)
			if ($click_tracking_code == "") {
				// click_tracking_code
				$url_code_length = 10;
				// generate code
				// exit with fatal error if a code can't be found in a reasonable number of trys
				$go = true;
				$short_url_chars = 'abcdefghijklmnopqrstuvwxyz0123456789';
				while($go){
					$short_url_code = '';
					for($i = 0; $i < $url_code_length; $i++){
						$pos = mt_rand(0, strlen($short_url_chars)-1);
						$short_url_code .= substr($short_url_chars, $pos, 1);
					}
					$short_url_code = 't' . $short_url_code;
					// is it already in use?
					$sql_temp = "SELECT * FROM click_trackers WHERE click_tracking_code = '$short_url_code'";
					$result_temp = $mysqli->query($sql_temp);
					if ($mysqli->connect_errno) {
						echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
						exit();
					}
					$count = $result_temp->num_rows;
					$result_temp->close();
					if ($count < 1) {
						$go = false;
					}
				} // end while
				$click_tracking_code = $short_url_code;
			} else {
					$click_tracking_code = 't' . $click_tracking_code;
			}
			// sanitize data as needed
			$description = sanitize($description, $mysqli);
			$url = sanitize($url, $mysqli);
			$secondary_url = sanitize($secondary_url, $mysqli);
			$notes = sanitize($notes, $mysqli);
			$country_codes_accepted = sanitize($country_codes_accepted, $mysqli);
			$country_codes_not_accepted = sanitize($country_codes_not_accepted, $mysqli);
			$stats_password = sanitize($stats_password, $mysqli);
			// save new click_trackers record
			$sql = "INSERT INTO click_trackers (description, click_tracker_type, url, maximum_clicks, secondary_url, date_click_tracker_created, click_tracking_code, country_codes_accepted, country_codes_not_accepted, stats_password, alert_when_number_clicks_sent, notes) values ('$description', '$click_tracker_type', '$url', $maximum_clicks, '$secondary_url', now(), '$click_tracking_code', '$country_codes_accepted', '$country_codes_not_accepted', '$stats_password', $alert_when_number_clicks_sent, '$notes')";
			$result = $mysqli->query($sql);
			if ($mysqli->connect_errno) {
				echo "Could not insert record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			// get click_trackers id
			$sql_temp = "SELECT * FROM click_trackers WHERE click_tracking_code = '$click_tracking_code'";
			$result_temp = $mysqli->query($sql_temp);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
			$row_temp = $result_temp->fetch_array(MYSQLI_BOTH);
			$click_trackers_id = $row_temp['id'];
			$result_temp->close();
			// create click tracking url to display
			$click_tracking_url = $tracker_url . "?a=" . $click_tracking_code;
			// add to rotator if selected
			// $add_to_rotator, $rotator_clicks_to_send
			if ($add_to_rotator > 0) {
				$click_rotators_id = $add_to_rotator;	
				$total_clicks_to_send = $rotator_clicks_to_send;
				$link_description = $description;
				$link_url = sanitize($click_tracking_url, $mysqli);
				// calculate series position (place last)
				$sql = "SELECT * FROM click_rotator_links WHERE click_rotators_id = $click_rotators_id ORDER BY series_position DESC";
				$result = $mysqli->query($sql);
				if ($mysqli->connect_errno) {
					echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
					exit();
				}
				$count = $result->num_rows;
				if ($count > 0) {
					$row = $result->fetch_array(MYSQLI_BOTH);
					$series_position = $row['series_position'] + 1;
					$result->close();
				} else {
					$series_position = 1;
				}
				// save new click_rotator_links record
				$sql = "INSERT INTO click_rotator_links (click_rotators_id, series_position, link_description, link_url, total_clicks_to_send) values ($click_rotators_id, $series_position, '$link_description', '$link_url', $total_clicks_to_send)";		
				$result = $mysqli->query($sql);
				if ($mysqli->connect_errno) {
					echo "Could not insert record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
					exit();
				}
			}
			// stripslashes as needed
			$description = stripslashes($description);
			$url = stripslashes($url);
			//$secondary_url = stripslashes($secondary_url);
			//$notes = stripslashes(str_replace('\r\n', "\n", $notes));
			//$country_codes_accepted = stripslashes($country_codes_accepted);
			//$country_codes_not_accepted = stripslashes($country_codes_not_accepted);
			$stats_password = stripslashes($stats_password);
			// create pixel url to display
			$pixel_tracking_code = "<img src='" . $pixel_tracker_url . "?ptl=main' width='1' height='1'>";
			// create stats url
			$stats_link = $stats_url . "?i=" . $click_trackers_id . "&p=" . $stats_password;
			// prep data as needed for display
			$displaymessage = "New click tracker has been created.";		
		}
		echo "<table>";
		if ($errorcount > 0) {
			echo "<tr>";
			echo "<td><span style=\"color: red;\"><b>$displaymessage</b></span></td>";
			echo "</tr>";
		} else {
			echo "<tr>";
			echo "<td><span style=\"color: green;\"><b>$displaymessage</b></span></td>";
			echo "</tr>";
			echo "<tr>";
			echo "<td width=\"162\">Click Tracking Link:</td>";
			echo "<td width=\"596\"><input type=\"text\" id=\"click_tracking_url\" name=\"click_tracking_url\" size=\"75\" value=\"$click_tracking_url\" readonly></td>";
			echo "</tr>";
			echo "<tr>";
			echo "<td width=\"162\">Pixel Code:</td>";
			echo "<td width=\"596\"><input type=\"text\" id=\"pixel_tracking_code\" name=\"pixel_tracking_code\" size=\"75\" value=\"$pixel_tracking_code\" readonly></td>";
			echo "</tr>";
			echo "<tr>";
			echo "<td width=\"162\">Stats Link:</td>";
			echo "<td width=\"596\"><input type=\"text\" id=\"stats_link\" name=\"stats_link\" size=\"75\" value=\"$stats_link\" readonly></td>";
			echo "</tr>";
		}
		echo "</table>";
		echo "<br>";
		break;
	case "":
		break;
} // end switch

// close up shop
$mysqli->close();
?>
