<?php

// My Click Boss - Version 1.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// get link id
$id = $_GET['id'];

// sanitize data
$id = sanitize($id, $mysqli);

$moved_id = $id;

// get click_rotators id and data
$sql = "SELECT * FROM click_rotator_links WHERE id = $id";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
// bypass hack attempt check
$count = $result->num_rows;
if ($count < 1) {
	echo "ERROR: Invalid record ID";
	$mysqli->close();
	exit();
}
// get any data needed
$row = $result->fetch_array(MYSQLI_BOTH);
$click_rotators_id = $row['click_rotators_id'];
$current_series_position = $row['series_position'];
$result->close();

// does member own this click rotator?
$sql = "SELECT * FROM click_rotators WHERE id = $click_rotators_id";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
// bypass hack attempt check
$count = $result->num_rows;
if ($count < 1) {
	echo "ERROR: Invalid record ID";
	$mysqli->close();
	exit();
}
// get any data needed
$row = $result->fetch_array(MYSQLI_BOTH);
$description = stripslashes($row['description']);
$result->close();

// get last position of series
$sql = "SELECT * FROM click_rotator_links WHERE click_rotators_id = $click_rotators_id ORDER BY series_position DESC";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$row = $result->fetch_array(MYSQLI_BOTH);
$last_series_position = $row['series_position'];

// is message already at the bottom? = #MAX (don't do anything)
if ($current_series_position < $last_series_position) {
	// lookup links in same series
	$sql = "SELECT * FROM click_rotator_links WHERE click_rotators_id = $click_rotators_id";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	// re-number links in series
	$count = $result->num_rows;
	// do we have more than 1 link? If not, do nothing
	if ($count > 1) {
		// set new series position
		$new_series_position = $current_series_position + 1;
		// build 2 dim array with ids and new series_positions
		$new_positions = array();
		$ii = 0;
		while ($row = $result->fetch_array(MYSQLI_BOTH)) {
			$id = $row['id'];
			$series_position = $row['series_position'];

			if ($series_position == $new_series_position) {
				// add in moved message here ?
				$new_positions[$ii]['id'] = $moved_id;
				$new_positions[$ii]['series_position'] = $new_series_position;
		
				$ii++;

				// subtract 1 to this messages position
				$new_positions[$ii]['id'] = $id;
				$new_positions[$ii]['series_position'] = $series_position - 1;
			} else {
				if ($id != $moved_id) {
					// just add as is
					$new_positions[$ii]['id'] = $id;
					$new_positions[$ii]['series_position'] = $series_position;
				}
			}
			// increment $ii
			$ii++;
		}

		// update table series_position field for each record
		// loop through array
		foreach($new_positions as $position_update) {
			$id = $position_update['id'];
			$series_position = $position_update['series_position'];
			$sql2 = "UPDATE click_rotator_links SET series_position = $series_position WHERE id = $id";
			$result2 = $mysqli->query($sql2);
			if ($mysqli->connect_errno) {
				echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
				exit();
			}
		}
	}
}

// close up shop
$mysqli->close();

// reload
header("Location: click-rotator-links.php?id=$click_rotators_id");

?>
