<?php

// My Click Boss - Version 3.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// get form fields
$tracker_types = $_POST['tracker_types'];
// Inbound, Outbound, Blank, All

// get ALL trackers that have sent traffic in the last 24 hours by $tracker_types
// filter on $tracker_types in while display loop
//$sql = "SELECT click_trackers_id, COUNT(*) as count FROM click_tracker_stats GROUP BY click_trackers_id WHERE click_date >= DATE_SUB( NOW(), INTERVAL 24 HOUR) ORDER BY (count) DESC";
$sql = "SELECT click_trackers_id, COUNT(*) as count FROM click_tracker_stats WHERE click_date >= DATE_SUB(NOW(), INTERVAL 24 HOUR) GROUP BY click_trackers_id ORDER BY (count) DESC";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// close up shop
//$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Trackers Sending Clicks Last 24 Hours</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Trackers Sending Clicks Last 24 Hours</h1></div><!-- END #page_name -->
	<div id="page_description">Tracker(s) sending clicks in the last 24 hours are listed below.</div><!-- END #page_description -->
	<div id="form_section">
<center>
	<table>
  <thead>
  <tr>
    <th class="listHeading">Tracker Description</th>
    <th class="listHeading">Clicks</th>
  </tr>
  </thead>
  <tbody>
<?php
while ($row = $result->fetch_array(MYSQLI_BOTH)) {
	$click_trackers_id = $row['click_trackers_id'];
	$count = $row['count'];
	// get tracker description
	$sql_temp = "SELECT * FROM click_trackers WHERE id = $click_trackers_id";
	$result_temp = $mysqli->query($sql_temp);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	$row_temp = $result_temp->fetch_array(MYSQLI_BOTH);
	$description = stripslashes($row_temp['description']);
	$click_tracker_type = $row_temp['click_tracker_type'];
	$result_temp->close();
	// do we show it?
	$display_it = "No";
	switch ($click_tracker_type) {
		case "I":
			if ($tracker_types == "Inbound" || $tracker_types == "All") {
				$display_it = "Yes";
			}
			break;
		case "O":
			if ($tracker_types == "Outbound" || $tracker_types == "All") {
				$display_it = "Yes";
			}
			break;
		default:
			if ($tracker_types == "Blank" || $tracker_types == "All") {
				$display_it = "Yes";
			}
			break;
	}
	if ($display_it == "Yes") {
		echo "<tr>";
		echo "<td>";
		echo "$description";
		echo "</td>";
		echo "<td>";
		echo "$count";
		echo "</td>";
		echo "</tr>";
	}
} // end while
// close up shop
$mysqli->close();
?>
  </tbody>
</table>
</center>
<br><br>
	</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
	