<?php

// My Click Boss - Version 1.0
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// get fields
$click_rotator_links_id = $_GET['id'];
$current_link_status = $_GET['status'];
$click_rotators_id = $_GET['rid'];

// sanitize data as needed
$click_rotator_links_id = sanitize($click_rotator_links_id, $mysqli);
$current_link_status = sanitize($current_link_status, $mysqli);
$click_rotators_id = sanitize($click_rotators_id, $mysqli);

// does member own this rotator?
// does member own the rotator?
$sql = "SELECT * FROM click_rotators WHERE id = $click_rotators_id";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_rotators: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
// bypass hack attempt check
$count = $result->num_rows;
if ($count < 1) {
	echo "ERROR: Invalid record ID";
	$mysqli->close();
	exit();
}
// get any data needed
$row = $result->fetch_array(MYSQLI_BOTH);
$description = stripslashes($row['description']);
$result->close();

// change link status
switch ($current_link_status) {
	case "Active":
		$sql = "UPDATE click_rotator_links SET link_status = 'Suspended' WHERE id = $click_rotator_links_id";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
		break;
	case "Suspended":
		$sql = "UPDATE click_rotator_links SET link_status = 'Active' WHERE id = $click_rotator_links_id";
		$result = $mysqli->query($sql);
		if ($mysqli->connect_errno) {
			echo "Could not select record in click_rotator_links: (" . $mysqli->errno . ") " . $mysqli->error;
			exit();
		}
		break;
}

// close up shop
$mysqli->close();

// redirect to rotator links list
header("Location: click-rotator-links.php?id=$click_rotators_id");

?>
