<?php

// My Click Boss - Version 3.1
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "config.inc.php";
include "functions.php";

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// session tracking
sec_session_start();
if(login_check($mysqli) != true) {
	// redirect to login form
	$mysqli->close();
	header("Location: login.php");	
}

// who is logged in? 
$members_id = $_SESSION['members_id'];
$login_username = $_SESSION['username'];

// get click_trackers id
$id = $_GET['id'];

// sanitize gets
$id = sanitize($id, $mysqli);

// get click_trackers record
$sql = "SELECT * FROM click_trackers WHERE id = $id";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_trackers: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
	
// bypass hack attempt check
$count = $result->num_rows;
if ($count < 1) {
	echo "ERROR: Invalid record ID";
	$mysqli->close();
	exit();
}

// get the click_trackers data
$row = $result->fetch_array(MYSQLI_BOTH);
$description = stripslashes($row['description']);
$url = stripslashes($row['url']);
$date_click_tracker_created = $row['date_click_tracker_created'];
$click_tracking_code = $row['click_tracking_code'];
$total_clicks = $row['total_clicks'];
$result->close();

// get data for click stats

// stats

// click_count_today_inbound
$sql = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && DATE(click_date) = CURDATE()";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_today_inbound = $result->num_rows;
//$result->close();

// click_count_yesterday_inbound
$sql = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && DATE(click_date) = DATE_SUB(CURDATE(), INTERVAL 1 DAY)";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_yesterday_inbound = $result->num_rows;
//$result->close();

// click_count_last_7_days_inbound
$sql = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && DATE(click_date) > DATE_SUB(CURDATE(), INTERVAL 7 DAY)";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_last_7_days_inbound = $result->num_rows;
//$result->close();

// click_count_last_30_days_inbound
$sql = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && DATE(click_date) > DATE_SUB(CURDATE(), INTERVAL 30 DAY)";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_last_30_days_inbound = $result->num_rows;
//$result->close();

// get inbound click metrics (referring urls, surfer ips, user agents, language etc)
$sql_inbound_click_metrics = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id ORDER BY click_date DESC";
$result_inbound_click_metrics = $mysqli->query($sql_inbound_click_metrics);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// get RAW inbound click metrics (referring urls, surfer ips, user agents, language etc)
$sql_inbound_raw_click_metrics = "SELECT * FROM click_tracker_raw_stats WHERE click_trackers_id = $id ORDER BY click_date DESC";
$result_inbound_raw_click_metrics = $mysqli->query($sql_inbound_raw_click_metrics);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_raw_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// get pixel stats count(DISTINCT pixel_location_slug) ???
$sql_pixel_stats = "SELECT pixel_location_slug, count(pixel_location_slug) AS slugcount FROM pixel_stats WHERE tracker_type = 'a' && tracker_id = $id GROUP BY pixel_location_slug ORDER BY pixel_location_slug ASC";
$result_pixel_stats = $mysqli->query($sql_pixel_stats);
if ($mysqli->connect_errno) {
	echo "Could not select record in pixel_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// get geo country counts
$sql_geo_stats = "SELECT country_code, country_name, count(country_code) AS countrycount FROM click_tracker_stats WHERE click_trackers_id = $id GROUP BY country_code ORDER BY country_code ASC";
$result_geo_stats = $mysqli->query($sql_geo_stats);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// calculate tier 1 country count and percentage ($total_clicks)
// US,CA,GB,AU,NZ
$tier1_total_count = 0;
// US
$sql_tier1 = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && country_code = 'US'";
$result_tier1 = $mysqli->query($sql_tier1);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$tier1_count = $result_tier1->num_rows;
//$result_tier1->close();
$tier1_total_count = $tier1_total_count + $tier1_count;
// CA
$sql_tier1 = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && country_code = 'CA'";
$result_tier1 = $mysqli->query($sql_tier1);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$tier1_count = $result_tier1->num_rows;
//$result_tier1->close();
$tier1_total_count = $tier1_total_count + $tier1_count;
// GB
$sql_tier1 = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && country_code = 'GB'";
$result_tier1 = $mysqli->query($sql_tier1);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$tier1_count = $result_tier1->num_rows;
//$result_tier1->close();
$tier1_total_count = $tier1_total_count + $tier1_count;
// AU
$sql_tier1 = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && country_code = 'AU'";
$result_tier1 = $mysqli->query($sql_tier1);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$tier1_count = $result_tier1->num_rows;
//$result_tier1->close();
$tier1_total_count = $tier1_total_count + $tier1_count;
// NZ
$sql_tier1 = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id && country_code = 'NZ'";
$result_tier1 = $mysqli->query($sql_tier1);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$tier1_count = $result_tier1->num_rows;
//$result_tier1->close();
$tier1_total_count = $tier1_total_count + $tier1_count;
// calculate tier 1 percentage
if ($total_clicks > 0) {
	$tier1countrypercentage = ($tier1_total_count / $total_clicks) * 100;
	$tier1countrypercentage = round($tier1countrypercentage, 1);
	$tier1countrypercentage = $tier1countrypercentage . "%";
} else {
	$tier1countrypercentage = "0%";
}

// get first click received on date
$sql_first_click = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id ORDER BY click_date ASC LIMIT 1";
$result_first_click = $mysqli->query($sql_first_click);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_first_click = $result_first_click->num_rows;
if ($click_count_first_click > 0) {
	$row_first_click = $result_first_click->fetch_array(MYSQLI_BOTH);
	$first_click_date = $row_first_click['click_date'];
	$result_first_click->close();
} else {
	$first_click_date = "none";
}

// get last click received on date
$sql_last_click = "SELECT * FROM click_tracker_stats WHERE click_trackers_id = $id ORDER BY click_date DESC LIMIT 1";
$result_last_click = $mysqli->query($sql_last_click);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_last_click = $result_last_click->num_rows;
if ($click_count_last_click > 0) {
	$row_last_click = $result_last_click->fetch_array(MYSQLI_BOTH);
	$last_click_date = $row_last_click['click_date'];
	$result_last_click->close();
} else {
	$last_click_date = "none";
}

// get raw click count
$sql = "SELECT * FROM click_tracker_raw_stats WHERE click_trackers_id = $id";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_raw_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$click_count_raw_inbound = $result->num_rows;
//$result->close();
$raw_clicks_total = $click_count_raw_inbound + $total_clicks;

// IP class distribution of unique clicks
$sql_ip_counts = "SELECT substr(surfer_ip, 1, locate('.', surfer_ip, locate('.', surfer_ip, locate('.', surfer_ip) + 1) + 1) - 1) AS subip, COUNT(surfer_ip) AS count FROM click_tracker_stats WHERE click_trackers_id = $id GROUP BY (subip) ORDER BY count DESC";
$result_ip_counts = $mysqli->query($sql_ip_counts);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}

// close up shop
//$mysqli->close();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>My Click Boss - Tracker Stats</title>
<meta content="en-us" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="reset.css" rel="stylesheet" type="text/css" />
<link href="styles.css" rel="stylesheet" type="text/css" />
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</head>
<body>
<div id="wrapper">
<div id="header">
</div><!-- END #header -->
<div id="top_menu">
	<?php include "top-menu.php"; ?>
</div><!-- END #top_menu -->
<div id="main">
	<div id="page_name">
		<h1>Tracker Stats</h1></div><!-- END #page_name -->
	<div id="page_description">Stats for the selected click tracker.</div><!-- END #page_description -->
	<div id="form_section">
<!--<center>-->
<table>
<tr>
<td width="162" class="txtRight bold">Description:</td>
<td width="596"><?php echo $description; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">URL:</td>
<td width="596"><?php echo $url; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Created on:</td>
<td width="596"><?php echo $date_click_tracker_created; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">First Click:</td>
<td width="596"><?php echo $first_click_date; ?></td>
</tr>
<tr>
<td width="162" class="txtRight bold">Last Click:</td>
<td width="596"><?php echo $last_click_date; ?></td>
</tr>
</table>
<br><br>
<!--</center>-->

<center>
<table align="center" cellpadding="2" style="border-style: solid; border-width: 1px;">
<tr>
<td style="border-style: solid; border-width: 1px;">
<center>
<table>
<tr>
<td style="font-size:20px">Click Stats</td>
</tr>
</table>
</center>

<center>
<table>
<tr>
   	<td>Clicks Today:</td>
    <td><?php echo $click_count_today_inbound; ?></td>
</tr>
<tr>
   	<td>Clicks Yesterday:</td>
    <td><?php echo $click_count_yesterday_inbound; ?></td>
</tr>
<tr>
   	<td>Clicks Last 7 Days:</td>
    <td><?php echo $click_count_last_7_days_inbound; ?></td>
</tr>
<tr>
   	<td>Clicks Last 30 Days:</td>
    <td><?php echo $click_count_last_30_days_inbound; ?></td>
</tr>
<tr>
   	<td>Total Unique Clicks:</td>
    <td><?php echo $total_clicks; ?></td>
</tr>		
<tr>
   	<td>Total Raw Clicks:</td>
    <td><?php echo $raw_clicks_total; ?></td>
</tr>		
<tr>
   	<td>Tier 1 Country Clicks:</td>
    <td><?php echo $tier1_total_count; ?></td>
</tr>		
<tr>
   	<td>Tier 1 Country Percentage:</td>
    <td><?php echo $tier1countrypercentage; ?></td>
</tr>		
</table>
</center>
</td>
<td rowspan="2" style="border-style: solid; border-width: 1px;">
<center>
<table>
<tr>
<td style="font-size:20px">GEO Stats</td>
</tr>
</table>
</center>

<center>
<table>
<tr>
   	<td><b>Country Code - Country Name - Unique - Percentage - Pixels:</b></td>
</tr>
<?php
while ($row_geo_stats = $result_geo_stats->fetch_array(MYSQLI_BOTH)) {
	$country_code = $row_geo_stats['country_code'];
	$country_name = $row_geo_stats['country_name'];
	$countrycount = $row_geo_stats['countrycount'];
	// calculate percentage $countrypercentage ($total_clicks)
	if ($total_clicks > 0) {
		$countrypercentage = ($countrycount / $total_clicks) * 100;
		$countrypercentage = round($countrypercentage, 1);
		$countrypercentage = $countrypercentage . "%";
	} else {
		$countrypercentage = "0%";
	}
	// get pixel fire count for this country and tracker
	$sql_pixel_fires_temp = "SELECT * FROM pixel_stats WHERE country_code = '$country_code' && tracker_id = $id && tracker_type = 'a' && pixel_location_slug = 'main'";
	$result_pixel_fires_temp = $mysqli->query($sql_pixel_fires_temp);
	if ($mysqli->connect_errno) {
		echo "Could not select record in pixel_stats: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	$pixel_fires_count = $result_pixel_fires_temp->num_rows;
	echo "<tr>";
	echo "<td>$country_code - $country_name - $countrycount - $countrypercentage - $pixel_fires_count</td>";
	echo "</tr>";
} // end while
//$result_geo_stats->close();
?>
</table>		
</center>
</td>
</tr>
<tr>
<td style="border-style: solid; border-width: 1px;">
<center>
<table>
<tr>
<td style="font-size:20px">Pixel Stats</td>
</tr>
</table>
</center>

<center>
<table>
<tr>
   	<td><b>Pixel Name - Count:</b></td>
</tr>
<?php
while ($row_pixel_stats = $result_pixel_stats->fetch_array(MYSQLI_BOTH)) {
	$pixel_location_slug = $row_pixel_stats['pixel_location_slug'];
	$slugcount = $row_pixel_stats['slugcount'];
	echo "<tr>";
	echo "<td>$pixel_location_slug - $slugcount</td>";
	echo "</tr>";
} // end while
//$result_pixel_stats->close();
?>
</table>		
</center>
</td>
</tr>
</table>
</center>

<br><br>

<center>
<table>
<tr>
   	<td><b>[IP Class Distribution of Unique Clicks (over 1)] IP Class - Count:</b></td>
</tr>
<tr><td></td></tr>
<tr><td></td></tr>
<?php
while ($row_ip_counts = $result_ip_counts->fetch_array(MYSQLI_BOTH)) {
	$subip = $row_ip_counts['subip'];
	$count = $row_ip_counts['count'];
	if ($count > 1) {
		echo "<tr>";
		echo "<td>$subip - $count</td>";
		echo "</tr>";
	}
} // end while
//$result_ip_counts->close();
?>
</table>		
</center>

<br><br>

<center>
<table>
<tr>
   	<td><b>[Unique Stats Dump] Date, IP, Referring URL, Country Code, Language, User Agent, IP Host:</b></td>
</tr>
<tr><td></td></tr>
<tr><td></td></tr>
<?php
while ($row_inbound_click_metrics = $result_inbound_click_metrics->fetch_array(MYSQLI_BOTH)) {
	$click_date = $row_inbound_click_metrics['click_date'];
	$surfer_ip = $row_inbound_click_metrics['surfer_ip'];
	$referring_url = stripslashes($row_inbound_click_metrics['referring_url']);
	$country_code = stripslashes($row_inbound_click_metrics['country_code']);
	$country_name = stripslashes($row_inbound_click_metrics['country_name']);
	$language_code = stripslashes($row_inbound_click_metrics['language_code']);
	$user_agent = stripslashes($row_inbound_click_metrics['user_agent']);
	$ip_host = stripslashes($row_inbound_click_metrics['ip_host']);
	echo "<tr>";
	echo "<td>$click_date - $surfer_ip - $referring_url - $country_code - $language_code - $user_agent - $ip_host</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td><hr></td>";
	echo "</tr>";
} // end while
//$result_inbound_click_metrics->close();
?>
</table>		
</center>

<br><br>

<center>
<table>
<tr>
   	<td><b>[Duplicate IP - Raw Stats Dump] Date, IP, Referring URL, Country Code, Language, User Agent, IP Host:</b></td>
</tr>
<tr><td></td></tr>
<tr><td></td></tr>
<?php
while ($row_inbound_raw_click_metrics = $result_inbound_raw_click_metrics->fetch_array(MYSQLI_BOTH)) {
	$click_date = $row_inbound_raw_click_metrics['click_date'];
	$surfer_ip = $row_inbound_raw_click_metrics['surfer_ip'];
	$referring_url = stripslashes($row_inbound_raw_click_metrics['referring_url']);
	$country_code = stripslashes($row_inbound_raw_click_metrics['country_code']);
	$country_name = stripslashes($row_inbound_raw_click_metrics['country_name']);
	$language_code = stripslashes($row_inbound_raw_click_metrics['language_code']);
	$user_agent = stripslashes($row_inbound_raw_click_metrics['user_agent']);
	$ip_host = stripslashes($row_inbound_raw_click_metrics['ip_host']);
	echo "<tr>";
	echo "<td>$click_date - $surfer_ip - $referring_url - $country_code - $language_code - $user_agent - $ip_host</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td><hr></td>";
	echo "</tr>";
} // end while
//$result_inbound_raw_click_metrics->close();
?>
</table>		
</center>
<br><br>
<?php
// close up shop
$mysqli->close();
?>
</div><!-- END #form_section -->
</div><!-- END #main -->
<div id="footer">
	<?php include "footer.php"; ?>
</div><!-- END #footer -->
<br><br>
</div><!-- END #wrapper -->
</body>
</html>
