<?php
header('Content-Type: image/gif');
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

// My Click Boss - Version 3.11
// Copyright (c) 2013 by RLW Publishing, all rights reserved.
// http://myclickboss.com/

include "admin/config.inc.php";
include "admin/functions.php";
include("geoip.inc");

// location slug
// slug named main shows fires for the tracker being listed

// get ptl (pixel tracker location slug) (slug named [main] shows in tracker lists)
$ptl = $_GET['ptl'];

// get surfers IP
$surfer_ip_address = GetUserIP();

// get referring url
if (isset($_SERVER['HTTP_REFERER'])) {
	$referring_url = $_SERVER['HTTP_REFERER'];
} else {
	$referring_url = "";
}

// get $_SERVER['HTTP_ACCEPT_LANGUAGE']
if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
	$accept_language_string = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
} else {
	$accept_language_string = "";
}

// get $_SERVER['HTTP_USER_AGENT']
if (isset($_SERVER['HTTP_USER_AGENT'])) {
	$user_agent_string = $_SERVER['HTTP_USER_AGENT'];
} else {
	$user_agent_string = "";
}

// get $_SERVER['REMOTE_HOST']
if (isset($_SERVER['REMOTE_HOST'])) {
	$ip_host = $_SERVER['REMOTE_HOST'];
} else {
	$ip_host = "";
}

// get geoip country_code
$gi = geoip_open("$path_to_geoip",GEOIP_STANDARD);
$country_code = geoip_country_code_by_addr($gi, $surfer_ip_address);
$country_name = geoip_country_name_by_addr($gi, $surfer_ip_address);
geoip_close($gi);

// connect to database
$mysqli = new mysqli(HOST, USER, PASSWORD, DATABASE);
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
	exit();
}

// sanitize all input data
$ptl = sanitize($ptl, $mysqli);

// what type of tracker and tracker id sent click?
$tracker_type = "n";
$tracker_id = 0;
$sql = "SELECT * FROM click_tracker_stats WHERE surfer_ip = '$surfer_ip_address' ORDER BY click_date DESC";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in click_tracker_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$count = $result->num_rows;
if ($count > 0) {
	$tracker_type = "a";
	$row = $result->fetch_array(MYSQLI_BOTH);
	$tracker_id = $row['click_trackers_id'];
	$result->close();
} else {
	// is it from an inbound click trade?
	$sql = "SELECT * FROM click_trade_stats WHERE inbound_outbound = 'i' && surfer_ip = '$surfer_ip_address' ORDER BY click_date DESC";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not select record in click_trade_stats: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}
	$count = $result->num_rows;
	if ($count > 0) {
		$tracker_type = "b";
		$row = $result->fetch_array(MYSQLI_BOTH);
		$tracker_id = $row['click_trades_id'];
		$result->close();
	}	
}

// has pixel fire already been recorded?
$sql = "SELECT * FROM pixel_stats WHERE tracker_type = '$tracker_type' && tracker_id = $tracker_id && surfer_ip = '$surfer_ip_address' && pixel_location_slug = '$ptl'";
$result = $mysqli->query($sql);
if ($mysqli->connect_errno) {
	echo "Could not select record in pixel_stats: (" . $mysqli->errno . ") " . $mysqli->error;
	exit();
}
$count = $result->num_rows;
//$result->close();

// if it has not already been recorded, then record the pixel fire
if ($count < 1) {
	$sql = "INSERT INTO pixel_stats (tracker_type, tracker_id, surfer_ip, pixel_fire_date, pixel_location_slug, referring_url, country_code, country_name, language_code, user_agent, ip_host) values ('$tracker_type', $tracker_id, '$surfer_ip_address', now(), '$ptl', '$referring_url', '$country_code', '$country_name', '$accept_language_string', '$user_agent_string', '$ip_host')";
	$result = $mysqli->query($sql);
	if ($mysqli->connect_errno) {
		echo "Could not insert record in pixel_stats: (" . $mysqli->errno . ") " . $mysqli->error;
		exit();
	}		
}

// close up shop
$mysqli->close();

echo base64_decode('R0lGODlhAQABAJAAAP8AAAAAACH5BAUQAAAALAAAAAABAAEAAAICBAEAOw==');
?>